* _tclr.s

	.include	doscall.mac
	.include	iocscall.mac
	.include	twin.mac

	.xdef	__tclr


	.offset	-(4+2)
link_start:
s_stat:		.ds.l	1
crtc_r21:	.ds.w	1
	.text


*-------------------------------------------------------------------------------
* __tclr
*
* entry:
*       d1.w = XW(0`1023)
*       d2.w = YW
*       d3.w = X size
*       d4.w = Y size > 0
*       a1.l = eLXgAhX

	.text
__tclr:
	link	a6,#link_start
	movem.l	d1-d7/a0-a1/a5,-(sp)
	move.l	a1,a5

	sub.l	a1,a1
	IOCS	__B_SUPER
	move.l	d0,s_stat(a6)
	move.w	$e8002a,crtc_r21(a6)
	and.w	#$fcff,$e8002a		* VOANZXrbg}XNIt

	move.w	#$0080,a1	* a1 = 
	and.l	#$0000ffff,d2
	lsl.l	#7,d2
	add.l	d2,a5		* a5 = YW
	move.w	d1,d5		* d5 = XW
	move.w	d3,d6		* d6 = X size
	move.w	d4,d7		* d7 = Y size

	lsr.w	#3,d1
	and.w	#%1111,d5
	add.w	d5,d5
	jsr	__tclr_tbl(pc,d5.w)
	moveq.l	#0,d1
__tclr_end:
	move.w	crtc_r21(a6),$e8002a
	move.l	s_stat(a6),d0
	bmi	@f
	move.l	d0,a1
	IOCS	__B_SUPER
@@:
	move.l	d1,d0
	movem.l	(sp)+,d1-d7/a0-a1/a5
	unlk	a6
	rts

__tclr_tbl:
	bra.s	__tclr80_e
	bra.s	__tclr81_e
	bra.s	__tclr82_e
	bra.s	__tclr83_e
	bra.s	__tclr84_e
	bra.s	__tclr85_e
	bra.s	__tclr86_e
	bra.s	__tclr87_e
	bra.s	__tclr80_o
	bra.s	__tclr81_o
	bra.s	__tclr82_o
	bra.s	__tclr83_o
	bra.s	__tclr84_o
	bra.s	__tclr85_o
	bra.s	__tclr86_o
	bra.s	__tclr87_o

__tclr80_e:
	moveq.l	#%1111_1111,d2
	subq.w	#8,d6
	bra	__tclr80_e1
__tclr81_e:
	moveq.l	#%0111_1111,d2
	subq.w	#7,d6
	bra	__tclr87_e1
__tclr82_e:
	moveq.l	#%0011_1111,d2
	subq.w	#6,d6
	bra	__tclr87_e1
__tclr83_e:
	moveq.l	#%0001_1111,d2
	subq.w	#5,d6
	bra	__tclr87_e1
__tclr84_e:
	moveq.l	#%0000_1111,d2
	subq.w	#4,d6
	bra	__tclr87_e1
__tclr85_e:
	moveq.l	#%0000_0111,d2
	subq.w	#3,d6
	bra	__tclr87_e1
__tclr86_e:
	moveq.l	#%0000_0011,d2
	subq.w	#2,d6
	bra	__tclr87_e1
__tclr87_e:
	moveq.l	#%0000_0001,d2
	subq.w	#1,d6
	bra	__tclr87_e1

__tclr80_o:
	moveq.l	#%1111_1111,d2
	subq.w	#8,d6
	bra	__tclr80_o1
__tclr81_o:
	moveq.l	#%0111_1111,d2
	subq.w	#7,d6
	bra	@f
__tclr82_o:
	moveq.l	#%0011_1111,d2
	subq.w	#6,d6
	bra	@f
__tclr83_o:
	moveq.l	#%0001_1111,d2
	subq.w	#5,d6
	bra	@f
__tclr84_o:
	moveq.l	#%0000_1111,d2
	subq.w	#4,d6
	bra	@f
__tclr85_o:
	moveq.l	#%0000_0111,d2
	subq.w	#3,d6
	bra	@f
__tclr86_o:
	moveq.l	#%0000_0011,d2
	subq.w	#2,d6
	bra	@f
__tclr87_o:
	moveq.l	#%0000_0001,d2
	subq.w	#1,d6
@@:
	add.w	d1,a5

	move.w	d6,d0
	ble	__tclr_s

	not.b	d2

	and.w	#%111,d0
	beq	@f
	subq.w	#1,d0
	moveq.l	#$80,d1
	asr.b	d0,d1
	not.b	d1
@@:
	moveq.l	#32,d3
	moveq.l	#0,d5
	subq.w	#1,d7
__tclr87_o_loop:
	move.l	a5,a0
	move.w	d6,d4

	and.b	d2,(a5)+		* [NA
@@:
	sub.w	d3,d4
	bmi	@f

	move.l	d5,(a5)+
	bra	@b
@@:
	add.w	d3,d4
	beq	__tclr87_o_loop_next
@@:
	subq.w	#8,d4
	bmi	@f

	move.b	d5,(a5)+
	bra	@b
@@:
	cmp.w	#-8,d4
	beq	__tclr87_o_loop_next

	and.b	d1,(a5)			* E[NA

__tclr87_o_loop_next:
	move.l	a0,a5
	add.w	a1,a5
	dbra	d7,__tclr87_o_loop
	rts

__tclr87_e1:
	add.w	d1,a5

	move.w	d6,d0
	ble	__tclr_s

	not.b	d2

	and.w	#%111,d0
	beq	@f
	subq.w	#1,d0
	moveq.l	#$80,d1
	asr.b	d0,d1
	not.b	d1
@@:
	moveq.l	#32,d3
	moveq.l	#0,d5
	subq.w	#1,d7
__tclr87_e_loop:
	move.l	a5,a0
	move.w	d6,d4

	and.b	d2,(a5)+		* [NA

	subq.w	#8,d4
	bmi	1f

	move.b	d5,(a5)+
@@:
	sub.w	d3,d4
	bmi	@f

	move.l	d5,(a5)+
	bra	@b
@@:
	add.w	d3,d4
	beq	__tclr87_e_loop_next
@@:
	subq.w	#8,d4
	bmi	@f

	move.b	d5,(a5)+
	bra	@b
@@:
	cmp.w	#-8,d4
	beq	__tclr87_e_loop_next
1:
	and.b	d1,(a5)			* E[NA

__tclr87_e_loop_next:
	move.l	a0,a5
	add.w	a1,a5
	dbra	d7,__tclr87_e_loop
	rts

__tclr_s:
	neg.w	d0
	beq	1f
	moveq.l	#$ff,d1
	lsl.b	d0,d1
	not.b	d1
	eor.b	d1,d2
1:
	not.b	d2
	subq.w	#1,d7
__tclr_s_loop:
	and.b	d2,(a5)

	add.w	a1,a5
	dbra	d7,__tclr_s_loop
	rts

__tclr80_e1:
	add.w	d1,a5

	move.w	d6,d0
	ble	__tclr_s
	addq.w	#8,d6

	and.w	#%111,d0
	beq	@f
	subq.w	#1,d0
	moveq.l	#$80,d1
	asr.b	d0,d1
	not.b	d1
@@:
	moveq.l	#32,d2
	moveq.l	#0,d5
	subq.w	#1,d7
__tclr80_e_loop:
	move.l	a5,a0
	move.w	d6,d4
@@:
	sub.w	d2,d4
	bmi	@f

	move.l	d5,(a5)+
	bra	@b
@@:
	add.w	d2,d4
	beq	__tclr80_e_loop_next
@@:
	subq.w	#8,d4
	bmi	@f

	move.b	d5,(a5)+
	bra	@b
@@:
	cmp.w	#-8,d4
	beq	__tclr80_e_loop_next

	and.b	d1,(a5)			* E[NA
__tclr80_e_loop_next:
	move.l	a0,a5
	add.w	a1,a5
	dbra	d7,__tclr80_e_loop
	rts

__tclr80_o1:
	add.w	d1,a5

	move.w	d6,d0
	ble	__tclr_s

	and.w	#%111,d0
	beq	@f
	subq.w	#1,d0
	moveq.l	#$80,d1
	asr.b	d0,d1
	not.b	d1
@@:
	moveq.l	#32,d2
	moveq.l	#0,d5
	subq.w	#1,d7
__tclr80_o_loop:
	move.l	a5,a0
	move.w	d6,d4

	move.b	d5,(a5)+
@@:
	sub.w	d2,d4
	bmi	@f

	move.l	d5,(a5)+
	bra	@b
@@:
	add.w	d2,d4
	beq	__tclr80_o_loop_next
@@:
	subq.w	#8,d4
	bmi	@f

	move.b	d5,(a5)+
	bra	@b
@@:
	cmp.w	#-8,d4
	beq	__tclr80_o_loop_next

	and.b	d1,(a5)			* E[NA

__tclr80_o_loop_next:
	move.l	a0,a5
	add.w	a1,a5
	dbra	d7,__tclr80_o_loop
	rts


	.end
