* _teor2.s

	.include	doscall.mac
	.include	iocscall.mac
	.include	twin.mac

	.xdef	__teor2


	.offset	-(4+2)
link_start:
s_stat:		.ds.l	1
crtc_r21:	.ds.w	1
	.text


*-------------------------------------------------------------------------------
* __teor2 (v[O^Pp^[)
*
* entry:
*       d1.w = XW(0`1023)
*       d2.w = YW
*       a0.l = [Nobt@(AhX ((XTCY+7)/8)*8*(YTCY)+4)oCgKv)
*         0(a0).w = XTCY(0`1023)
*         2(a0).w = YTCY
*       a1.l = eLXgAhX

	.text
__teor2:
	link	a6,#link_start
	movem.l	d1-d7/a0-a1/a3-a5,-(sp)
	move.l	a0,a4
	move.l	a1,a5

	sub.l	a1,a1
	IOCS	__B_SUPER
	move.l	d0,s_stat(a6)
	move.w	$e8002a,crtc_r21(a6)
	and.w	#$fcff,$e8002a		* VOANZXrbg}XNIt

	move.w	#$0080,a1	* a1 = 
	and.l	#$0000ffff,d2
	lsl.l	#7,d2
	add.l	d2,a5		* a5 = YW
	move.l	a5,a3
	add.l	#$20000,a3	* a3 = v[P
	move.w	d1,d5		* d5 = XW

	move.w	(a4)+,d6
	move.w	(a4)+,d7

	lsr.w	#3,d1
	and.w	#%111,d5
	add.w	d5,d5
	jsr	__teor2_tbl(pc,d5.w)
	moveq.l	#0,d1
__teor2_end:
	move.w	crtc_r21(a6),$e8002a
	move.l	s_stat(a6),d0
	bmi	@f
	move.l	d0,a1
	IOCS	__B_SUPER
@@:
	move.l	d1,d0
	movem.l	(sp)+,d1-d7/a0-a1/a3-a5
	unlk	a6
	rts

__teor2_tbl:
	bra.s	__teor280
	bra.s	__teor281
	bra.s	__teor282
	bra.s	__teor283
	bra.s	__teor284
	bra.s	__teor285
	bra.s	__teor286
	bra.s	__teor287

__teor280:
	moveq.l	#%1111_1111,d2
	moveq.l	#0,d3
	subq.w	#8,d6

	btst.l	#0,d1
	bne	__teor280_o
	bra	__teor280_e
__teor281:
	moveq.l	#%0111_1111,d2
	moveq.l	#1,d3
	subq.w	#7,d6
	bra	@f
__teor282:
	moveq.l	#%0011_1111,d2
	moveq.l	#2,d3
	subq.w	#6,d6
	bra	@f
__teor283:
	moveq.l	#%0001_1111,d2
	moveq.l	#3,d3
	subq.w	#5,d6
	bra	@f
__teor284:
	moveq.l	#%0000_1111,d2
	moveq.l	#4,d3
	subq.w	#4,d6
	bra	@f
__teor285:
	moveq.l	#%0000_0111,d2
	moveq.l	#5,d3
	subq.w	#3,d6
	bra	@f
__teor286:
	moveq.l	#%0000_0011,d2
	moveq.l	#6,d3
	subq.w	#2,d6
	bra	@f
__teor287:
	moveq.l	#%0000_0001,d2
	moveq.l	#7,d3
	subq.w	#1,d6
@@:
	add.w	d1,a5
	add.w	d1,a3

	move.w	d6,d0
	ble	__teor2_s

	and.w	#%111,d0
	beq	@f
	subq.w	#1,d0
	moveq.l	#$80,d1
	asr.b	d0,d1
@@:
	subq.l	#1,d7
__teor287_loop:
	movem.l	d7/a3/a5,-(sp)
	move.w	d6,d4

	move.b	(a4)+,d7
	move.b	d7,d0
	lsr.b	d3,d0
	and.b	d2,d0
	eor.b	d0,(a5)+
	eor.b	d0,(a3)+
@@:
	subq.w	#8,d4
	ble	@f

	lsl.w	#8,d7
	move.b	(a4)+,d7
	move.w	d7,d0
	lsr.w	d3,d0
	eor.b	d0,(a5)+
	eor.b	d0,(a3)+

	bra	@b
@@:
	tst.w	d4
	bne	@f

	lsl.w	#8,d7
	move.b	(a4)+,d7
	move.w	d7,d0
	lsr.w	d3,d0
	eor.b	d0,(a5)+
	eor.b	d0,(a3)+

	bra	__teor287_loop_next

@@:
	addq.w	#8,d4
	lsl.w	#8,d7
	cmp.w	d4,d3		* c̃rbgő邩ȁH
	bcc	@f
	move.b	(a4)+,d7
@@:
	lsr.w	d3,d7
	and.b	d1,d7
	eor.b	d7,(a5)+
	eor.b	d7,(a3)+

__teor287_loop_next:
	movem.l	(sp)+,d7/a3/a5
	add.w	a1,a5
	add.w	a1,a3
	dbra	d7,__teor287_loop
	rts

__teor2_s:
	neg.w	d0
	beq	1f
	moveq.l	#$ff,d1
	lsl.b	d0,d1
	not.b	d1
	eor.b	d1,d2
1:
	subq.w	#1,d7
__teor2_s_loop:
	move.b	(a4)+,d0
	lsr.b	d3,d0
	and.b	d2,d0
	eor.b	d0,(a5)
	eor.b	d0,(a3)

	add.w	a1,a5
	add.w	a1,a3
	dbra	d7,__teor2_s_loop
	rts

__teor280_e:
__teor280_o:
	add.w	d1,a5
	add.w	d1,a3

	move.w	d6,d0
	ble	__teor2_s

	and.w	#%111,d0
	beq	@f
	subq.w	#1,d0
	moveq.l	#$80,d1
	asr.b	d0,d1
@@:
	subq.l	#1,d7
__teor280_e_loop:
	move.l	a5,d5
	move.l	a3,d2
	move.w	d6,d4

	move.b	(a4)+,d0
	eor.b	d0,(a5)+
	eor.b	d0,(a3)+
@@:
	subq.w	#8,d4
	ble	@f

	move.b	(a4)+,d0
	eor.b	d0,(a5)+
	eor.b	d0,(a3)+
	bra	@b
@@:
	tst.w	d4
	bne	@f

	move.b	(a4)+,d0
	eor.b	d0,(a5)+
	eor.b	d0,(a3)+

	bra	__teor280_e_loop_next

@@:
	move.b	(a4)+,d0
	and.b	d1,d0
	eor.b	d0,(a5)+
	eor.b	d0,(a3)+

__teor280_e_loop_next:
	move.l	d5,a5
	move.l	d2,a3
	add.w	a1,a5
	add.w	a1,a3
	dbra	d7,__teor280_e_loop
	rts


	.end
