* _tputs.s

	.include	doscall.mac
	.include	iocscall.mac
	.include	twin.mac
	.lall

	.xdef	__tputs
	.xdef	__tputc
	.xdef	__tputf

	.xref	__twincuron
	.xref	__twincuroff

	.xref	__tclr3
	.xref	__tycopy

	.xref	twin_font
	.xref	twin_font12
	.xref	twin_font24

	.xref	twin_pt8_zero
	.xref	twin_pt_zero
	.xref	twin_pt6_zero
	.xref	twin_pt12_zero
	.xref	twin_pt12_24_zero
	.xref	twin_pt24_zero

*-------------------------------------------------------------------------------
* __tputc
*
* entry:
*       d0.l = (2oCgS-JIS)
*       a0.l = EBhE|C^

	.text
__tputc:
	link	a6,#-4
	lea	-4(a6),a1
	move.w	d0,d1
	lsr.w	#8,d1
	tst.b	d1
	beq	@@f
	cmp.b	#$e0,d1
	bcc	@f
	cmp.b	#$a0,d1
	bcc	__tputc_error
	cmp.b	#$80,d1
	bcc	@f
	bra	__tputc_error
@@:
	move.b	d1,(a1)+
@@:
	move.b	d0,(a1)+
	clr.b	(a1)+
	lea	-4(a6),a1
	bsr	__tputs
__tputc_end:
	unlk	a6
	rts

__tputc_error:
	moveq.l	#-1,d0
	bra	__tputc_end

*-------------------------------------------------------------------------------
* __tputf
* J[\ʒuɃp^[\.
*
* entry:
*       a0.l = EBhE|C^
*       a1.l = \p^[(24*24őTCY)

	.text
__tputf:
	link	a6,#link_start
	movem.l	d3-d7/a3-a5,-(sp)
	move.l	a0,a3			* a3 = TWIN|C^
	move.l	a1,a4			* a4 = \p^[

	clr.w	d0
	move.b	tcursw(a0),d0
	move.w	d0,cursw(a6)
	jsr	__twincuroff

	sub.l	a1,a1
	IOCS	__B_SUPER
	move.l	d0,s_stat(a6)
	move.w	$e8002a,crtc_r21(a6)

	move.w	tfsize(a3),d6		* d6.w tHgTCY
	lsr.w	#1,d6			* d6.w = (tHgTCY/2)
	bsr	_cury_calc		* a5 = eLXgxW擪
	bsr	_curx_calc
	bsr	__tputs_color_set	* d7.w = \J[
					* rbg}XNIt

	move.l	#twin_font,fnt_adr(a6)
	move.w	#1,fnt_size(a6)
	cmp.w	#8,d6
	beq	@f
	move.l	#twin_font12,fnt_adr(a6)
	cmp.w	#6,d6
	beq	@f
	move.w	#2,fnt_size(a6)
	move.l	#twin_font24,fnt_adr(a6)
@@:

	move.l	a4,a1
	jsr	__tputs_fntput

	moveq.l	#0,d0			* I
__tputf_end:
	move.l	d0,d1
	move.w	crtc_r21(a6),$e8002a
	move.l	s_stat(a6),d0
	bmi	@f
	move.l	d0,a1
	IOCS	__B_SUPER
@@:
	move.l	d1,d0
	move.l	a3,a0

	tst.w	cursw(a6)
	beq	@f
	jsr	__twincuron
@@:
	movem.l	(sp)+,d3-d7/a3-a5
	unlk	a6
	rts

*-------------------------------------------------------------------------------
* __tputs
*
* entry:
*       a0.l = EBhE|C^
*       a1.l = |C^(S-JIS)

	.offset	-(4+2*6+4+2+4+72)
link_start:
s_stat:		.ds.l	1
crtc_r21:	.ds.w	1
cursw:		.ds.w	1
posx:		.ds.w	1
posy:		.ds.w	1
x:		.ds.w	1
y:		.ds.w	1
fnt_adr:	.ds.l	1
fnt_size:	.ds.w	1
fnt_work:	.ds.w	2
fnt_data:	.ds.b	72
	.text

	.text
__tputs:
	link	a6,#link_start
	movem.l	d3-d7/a3-a5,-(sp)
	move.l	a0,a3			* a3 = TWIN|C^
	move.l	a1,a4			* a4 = |C^

	clr.w	d0
	move.b	tcursw(a0),d0
	move.w	d0,cursw(a6)
	jsr	__twincuroff

	sub.l	a1,a1
	IOCS	__B_SUPER
	move.l	d0,s_stat(a6)
	move.w	$e8002a,crtc_r21(a6)

	move.w	tfsize(a3),d6		* d6.w tHgTCY
	lsr.w	#1,d6			* d6.w = (tHgTCY/2)
	bsr	_cury_calc		* a5 = eLXgxW擪
	bsr	_curx_calc
	bsr	__tputs_color_set	* d7.w = \J[
					* rbg}XNIt

	move.l	#twin_font,fnt_adr(a6)
	move.w	#1,fnt_size(a6)
	cmp.w	#8,d6
	beq	@f
	move.l	#twin_font12,fnt_adr(a6)
	cmp.w	#6,d6
	beq	@f
	move.l	#twin_font24,fnt_adr(a6)
	move.w	#2,fnt_size(a6)
@@:

__tputs_loop:
	move.w	tescbuf(a3),d1
	beq	@f
	move.b	(a4)+,d0
	beq	__tputs_loop_end	* f[^Ȃ.
	cmp.w	#$8000,d1
	bcc	__tputs_kanji2		* obt@ɎcĂ.
	cmp.b	#$1b,tescbuf(a3)	* ESCV[PXH
	beq	__tputs_esc
	bra	__tputs_kanji2
@@:
	move.b	(a4)+,d1
	move.w	d1,d0
	add.w	d0,d0
	move.w	__tputs_tbl(pc,d0.w),d0
	jmp	__tputs_tbl(pc,d0.w)

__tputs_tbl:
	.dc.w	__tputs_loop_end-__tputs_tbl
	.rept	($20-$01)
	.dc.w	__tputs_ctrl-__tputs_tbl
	.endm
	.rept	($7f-$20)
	.dc.w	__tputs_ank-__tputs_tbl
	.endm
	.dc.w	__tputs_ank-__tputs_tbl		* DEL
	.rept	($a0-$80)
	.dc.w	__tputs_kanji-__tputs_tbl
	.endm
	.rept	($e0-$a0)
	.dc.w	__tputs_ank-__tputs_tbl
	.endm
	.rept	($100-$e0)
	.dc.w	__tputs_kanji-__tputs_tbl
	.endm

__tputs_kanji:
	move.b	d1,tescbuf(a3)
	bra	__tputs_loop
__tputs_kanji2:
	clr.b	tescbuf(a3)
	or.b	d0,d1
	pea	__tputs_loop(pc)
	bra	__tputs_sub
__tputs_ank:
	pea	__tputs_loop(pc)
	bra	__tputs_sub_ank
__tputs_ctrl:
	pea	__tputs_loop(pc)
	bra	__tputs_ctrl_sub
__tputs_esc:				* ESCV[PX̃`FbN
	lea	tescbuf+1(a3),a0
	clr.w	d1
	move.b	(a0),d1
	addq.b	#1,(a0)+
	move.b	d0,(a0,d1.w)		* V[PXgbv
	move.b	d0,d1
	pea	__tputs_loop(pc)
	bra	_escsq_check

__tputs_loop_end:
	moveq.l	#0,d0			* I
__tputs_end:
	move.l	d0,d1
	move.w	crtc_r21(a6),$e8002a
	move.l	s_stat(a6),d0
	bmi	@f
	move.l	d0,a1
	IOCS	__B_SUPER
@@:
	move.l	d1,d0
	move.l	a3,a0

	tst.w	cursw(a6)
	beq	@f
	jsr	__twincuron
@@:
	movem.l	(sp)+,d3-d7/a3-a5
	unlk	a6
	rts

__tputs_color_set:
	move.w	tpcol(a3),d7
	cmp.w	#8,d6
	beq	@f
	moveq.l	#$33,d0
	move.w	d0,$e8002a
	add.w	d7,d7
	add.w	d7,d7
	rts
@@:
	move.l	tvram(a3),d0
	swap.w	d0
	lsr.w	#1,d0
	moveq.l	#$33,d1
	rol.b	d0,d1

	add.w	d7,d7
	or.w	__tputs_color_set_tbl(pc,d7.w),d1
	move.w	d1,$e8002a
	add.w	d7,d7
	rts

__tputs_color_set_tbl:
	.dc.w	$0100		* m[}
	.dc.w	$0000
	.dc.w	$0000
	.dc.w	$0100
	.dc.w	$0100		* 
	.dc.w	$0000
	.dc.w	$0000
	.dc.w	$0100
	.dc.w	$0100		* ]
	.dc.w	$0000
	.dc.w	$0000
	.dc.w	$0100
	.dc.w	$0100		* {]
	.dc.w	$0000
	.dc.w	$0000
	.dc.w	$0100

__tputs_sub:
	cmp.w	#$8640,d1
	bcs	__tputs_fntget
	cmp.w	#$86FC+1,d1
	bcc	__tputs_fntget

	move.l	fnt_adr(a6),a1		* gtHg
	sub.w	#$8640,d1
	add.w	d1,d1
	add.w	d1,d1
	move.l	(a1,d1.w),a1
__tputs_fntput:
	move.w	(a1)+,d1
	move.w	(a1)+,d2
	addq.w	#7,d1
	lsr.w	#3,d1
	subq.w	#1,d1
	bra	__tputs_fntmd

__tputs_sub_ank:
__tputs_fntget:
	move.l	d6,d2
*	IOCS	__FNTADR
	move.l	($400+__FNTADR*4).w,a0
	jsr	(a0)
	move.l	d0,a1

__tputs_fntmd:
	move.w	d6,d3
	add.w	d1,d3
	add.w	d3,d3
	move.w	__tputs_fntsize_tbl(pc,d3.w),d0
	or.w	d7,d0
	jmp	__tputs_fntmd_tbl(pc,d0.w)

__tputs_fntsize_tbl:
	.dc.w	0
	.dc.w	0
	.dc.w	0
	.dc.w	0
	.dc.w	0
	.dc.w	0
	.dc.w	$0000	*  6x12
	.dc.w	$0080	* 12x12
	.dc.w	$0040	*  8x16
	.dc.w	$00c0	* 16x16
	.dc.w	0
	.dc.w	0
	.dc.w	0
	.dc.w	$0100	* 12x24
	.dc.w	$0140	* 24x24

__tputs_fntmd_tbl:
	bra.w	__tputs_fntmd00_6	* m[}
	bra.w	__tputs_fntmd01_6
	bra.w	__tputs_fntmd02_6
	bra.w	__tputs_fntmd03_6
	bra.w	__tputs_fntmd10_6	* 
	bra.w	__tputs_fntmd11_6
	bra.w	__tputs_fntmd12_6
	bra.w	__tputs_fntmd13_6
	bra.w	__tputs_fntmd20_6	* ]
	bra.w	__tputs_fntmd21_6
	bra.w	__tputs_fntmd22_6
	bra.w	__tputs_fntmd23_6
	bra.w	__tputs_fntmd30_6	* {]
	bra.w	__tputs_fntmd31_6
	bra.w	__tputs_fntmd32_6
	bra.w	__tputs_fntmd33_6

	bra.w	__tputs_fntmd00_8	* m[}
	bra.w	__tputs_fntmd01_8
	bra.w	__tputs_fntmd02_8
	bra.w	__tputs_fntmd03_8
	bra.w	__tputs_fntmd10_8	* 
	bra.w	__tputs_fntmd11_8
	bra.w	__tputs_fntmd12_8
	bra.w	__tputs_fntmd13_8
	bra.w	__tputs_fntmd20_8	* ]
	bra.w	__tputs_fntmd21_8
	bra.w	__tputs_fntmd22_8
	bra.w	__tputs_fntmd23_8
	bra.w	__tputs_fntmd30_8	* {]
	bra.w	__tputs_fntmd31_8
	bra.w	__tputs_fntmd32_8
	bra.w	__tputs_fntmd33_8

	bra.w	__tputs_fntmd00_12	* m[}
	bra.w	__tputs_fntmd01_12
	bra.w	__tputs_fntmd02_12
	bra.w	__tputs_fntmd03_12
	bra.w	__tputs_fntmd10_12	* 
	bra.w	__tputs_fntmd11_12
	bra.w	__tputs_fntmd12_12
	bra.w	__tputs_fntmd13_12
	bra.w	__tputs_fntmd20_12	* ]
	bra.w	__tputs_fntmd21_12
	bra.w	__tputs_fntmd22_12
	bra.w	__tputs_fntmd23_12
	bra.w	__tputs_fntmd30_12	* {]
	bra.w	__tputs_fntmd31_12
	bra.w	__tputs_fntmd32_12
	bra.w	__tputs_fntmd33_12

	bra.w	__tputs_fntmd00_16	* m[}
	bra.w	__tputs_fntmd01_16
	bra.w	__tputs_fntmd02_16
	bra.w	__tputs_fntmd03_16
	bra.w	__tputs_fntmd10_16	* 
	bra.w	__tputs_fntmd11_16
	bra.w	__tputs_fntmd12_16
	bra.w	__tputs_fntmd13_16
	bra.w	__tputs_fntmd20_16	* ]
	bra.w	__tputs_fntmd21_16
	bra.w	__tputs_fntmd22_16
	bra.w	__tputs_fntmd23_16
	bra.w	__tputs_fntmd30_16	* {]
	bra.w	__tputs_fntmd31_16
	bra.w	__tputs_fntmd32_16
	bra.w	__tputs_fntmd33_16

	bra.w	__tputs_fntmd00_12_24	* m[}
	bra.w	__tputs_fntmd01_12_24
	bra.w	__tputs_fntmd02_12_24
	bra.w	__tputs_fntmd03_12_24
	bra.w	__tputs_fntmd10_12_24	* 
	bra.w	__tputs_fntmd11_12_24
	bra.w	__tputs_fntmd12_12_24
	bra.w	__tputs_fntmd13_12_24
	bra.w	__tputs_fntmd20_12_24	* ]
	bra.w	__tputs_fntmd21_12_24
	bra.w	__tputs_fntmd22_12_24
	bra.w	__tputs_fntmd23_12_24
	bra.w	__tputs_fntmd30_12_24	* {]
	bra.w	__tputs_fntmd31_12_24
	bra.w	__tputs_fntmd32_12_24
	bra.w	__tputs_fntmd33_12_24

	bra.w	__tputs_fntmd00_24	* m[}
	bra.w	__tputs_fntmd01_24
	bra.w	__tputs_fntmd02_24
	bra.w	__tputs_fntmd03_24
	bra.w	__tputs_fntmd10_24	* 
	bra.w	__tputs_fntmd11_24
	bra.w	__tputs_fntmd12_24
	bra.w	__tputs_fntmd13_24
	bra.w	__tputs_fntmd20_24	* ]
	bra.w	__tputs_fntmd21_24
	bra.w	__tputs_fntmd22_24
	bra.w	__tputs_fntmd23_24
	bra.w	__tputs_fntmd30_24	* {]
	bra.w	__tputs_fntmd31_24
	bra.w	__tputs_fntmd32_24
	bra.w	__tputs_fntmd33_24


__tputs_fntmd01_8:
	lea	twin_pt8_zero+4,a2
	bra	@f
__tputs_fntmd02_8:
	move.l	a1,a2
	lea	twin_pt8_zero+4,a1
@@:
	move.w	tcurx(a3),d0
	cmp.w	txmax(a3),d0
	bls	@f
	bsr	_cur_crlf
@@:
	move.l	a5,d0
	add.w	posx(a6),a5
	move.l	a5,a0
	add.l	#$20000,a0

_address	=	$0000
	.rept	16
	move.b	(a1)+,_address(a5)
	move.b	(a2)+,_address(a0)
_address	=	_address+$0080
	.endm

	move.l	d0,a5
	bsr	_cur_right
	rts

__tputs_fntmd00_8:
	lea	twin_pt8_zero+4,a1
__tputs_fntmd03_8:
	move.w	tcurx(a3),d0
	cmp.w	txmax(a3),d0
	bls	@f
	bsr	_cur_crlf
	moveq.l	#0,d0
@@:
	move.l	a5,a0
	add.w	posx(a6),a0

_address	=	$0000
	.rept	16
	move.b	(a1)+,_address(a0)
_address	=	_address+$0080
	.endm

	bsr	_cur_right
	rts


__tputs_fntmd01_16:
	lea	twin_pt_zero+4,a2
	bra	@f
__tputs_fntmd02_16:
	move.l	a1,a2
	lea	twin_pt_zero+4,a1
@@:
	move.w	tcurx(a3),d0
	cmp.w	txmax(a3),d0
	bcs	@f
	bsr	_cur_crlf
@@:
	move.l	a5,d0
	add.w	posx(a6),a5
	move.l	a5,a0
	add.l	#$20000,a0

	btst.l	#0,d1
	beq	__tputs_02_16_even

_address	=	$0000
	.rept	16
	move.b	(a1)+,_address(a5)
	move.b	(a1)+,_address+1(a5)
	move.b	(a2)+,_address(a0)
	move.b	(a2)+,_address+1(a0)
_address	=	_address+$0080
	.endm

	move.l	d0,a5
	bsr	_cur_right2
	rts

__tputs_02_16_even:
_address	=	$0000
	.rept	16
	move.w	(a1)+,_address(a5)
	move.w	(a2)+,_address(a0)
_address	=	_address+$0080
	.endm

	move.l	d0,a5
	bsr	_cur_right2
	rts

__tputs_fntmd00_16:
	lea	twin_pt_zero+4,a1
__tputs_fntmd03_16:
	move.w	tcurx(a3),d0
	cmp.w	txmax(a3),d0
	bcs	@f
	bsr	_cur_crlf
@@:
	move.l	a5,a0
	add.w	posx(a6),a0

	btst.l	#0,d1
	beq	__tputs_16_even

_address	=	$0000
	.rept	16
	move.b	(a1)+,_address(a0)
	move.b	(a1)+,_address+1(a0)
_address	=	_address+$0080
	.endm

	bsr	_cur_right2
	rts

__tputs_16_even:
_address	=	$0000
	.rept	16
	move.w	(a1)+,_address(a0)
_address	=	_address+$0080
	.endm

	bsr	_cur_right2
	rts


__tputs_fntmd00_6:
	lea	twin_pt6_zero+4,a1
	move.l	a1,a2
	bra	@f
__tputs_fntmd01_6:
	lea	twin_pt6_zero+4,a2
	bra	@f
__tputs_fntmd02_6:
	move.l	a1,a2
	lea	twin_pt6_zero+4,a1
	bra	@f
__tputs_fntmd03_6:
	move.l	a1,a2
@@:
	move.w	tcurx(a3),d0
	cmp.w	txmax(a3),d0
	bls	@f
	bsr	_cur_crlf
@@:
	move.w	x(a6),d1
	move.w	d1,d0
	lsr.w	#3,d1

	move.l	a5,d5
	add.w	d1,a5
	move.l	a5,a0
	add.l	#$20000,a0

	and.w	#%1110,d0
	add.w	d0,d0

	jmp	__tputs_6_tbl(pc,d0.w)

__tputs_6_tbl:
	bra.w	__tputs_60
	bra.w	__tputs_63
	bra.w	__tputs_66
	bra.w	__tputs_61
	bra.w	__tputs_64
	bra.w	__tputs_67
	bra.w	__tputs_62
	bra.w	__tputs_65

__tputs_63:
__tputs_67:
	moveq.l	#%0011_1111,d2
	moveq.l	#%1100_0000,d4
	moveq.l	#2,d3

	movem.l	d5/a3,-(sp)
	move.w	#$0080,a3
	moveq.l	#12-1,d5
1:
	move.b	(a1)+,d0
	lsr.b	d3,d0
	and.b	d2,d0
	and.b	d4,(a5)
	or.b	d0,(a5)

	move.b	(a2)+,d0
	lsr.b	d3,d0
	and.b	d2,d0
	and.b	d4,(a0)
	or.b	d0,(a0)

	add.w	a3,a5
	add.w	a3,a0
	dbra	d5,1b
	movem.l	(sp)+,d5/a3

	move.l	d5,a5
	bsr	_cur_right
	rts

__tputs_60:
__tputs_64:
	moveq.l	#%1111_1100,d2
	moveq.l	#%0000_0011,d4

	movem.l	d5/a3,-(sp)
	move.w	#$0080,a3
	moveq.l	#12-1,d5
1:
	move.b	(a1)+,d0
	and.b	d2,d0
	and.b	d4,(a5)
	or.b	d0,(a5)

	move.b	(a2)+,d0
	and.b	d2,d0
	and.b	d4,(a0)
	or.b	d0,(a0)

	add.w	a3,a5
	add.w	a3,a0
	dbra	d5,1b
	movem.l	(sp)+,d5/a3

	move.l	d5,a5
	bsr	_cur_right
	rts

__tputs_66:
	move.w	#%0000_1111_1100_0000,d2
	move.w	#%1111_0000_0011_1111,d4
	moveq.l	#4,d3
	bra	@f
__tputs_61:
	move.w	#%0000_0011_1111_0000,d2
	move.w	#%1111_1100_0000_1111,d4
	moveq.l	#2,d3
@@:
	movem.l	d5/a3,-(sp)
	move.w	#$0080,a3
	moveq.l	#12-1,d5
1:
	move.b	(a1)+,d0
	lsl.w	d3,d0
	and.w	d2,d0
	and.w	d4,(a5)
	or.w	d0,(a5)

	move.b	(a2)+,d0
	lsl.w	d3,d0
	and.w	d2,d0
	and.w	d4,(a0)
	or.w	d0,(a0)

	add.w	a3,a5
	add.w	a3,a0
	dbra	d5,1b
	movem.l	(sp)+,d5/a3

	move.l	d5,a5
	bsr	_cur_right
	rts

__tputs_65:
	move.l	#%0000_0000_0000_0011_1111_0000_0000_0000,d2
	move.l	#%1111_1111_1111_1100_0000_1111_1111_1111,d4
	moveq.l	#6,d3
	bra	@f

__tputs_62:
	move.l	#%0000_0000_0000_1111_1100_0000_0000_0000,d2
	move.l	#%1111_1111_1111_0000_0011_1111_1111_1111,d4
	moveq.l	#4,d3
@@:
	subq.w	#1,a5
	subq.w	#1,a0

	movem.l	d5/a3,-(sp)
	move.w	#$0080,a3
	moveq.l	#12-1,d5
1:
	move.b	(a1)+,d0
	swap.w	d0
	lsr.l	d3,d0
	and.l	d2,d0
	and.l	d4,(a5)
	or.l	d0,(a5)

	move.b	(a2)+,d0
	swap.w	d0
	lsr.l	d3,d0
	and.l	d2,d0
	and.l	d4,(a0)
	or.l	d0,(a0)

	add.w	a3,a5
	add.w	a3,a0
	dbra	d5,1b
	movem.l	(sp)+,d5/a3

	move.l	d5,a5
	bsr	_cur_right
	rts


__tputs_fntmd00_12:
	lea	twin_pt12_zero+4,a1
	move.l	a1,a2
	bra	@f
__tputs_fntmd01_12:
	lea	twin_pt12_zero+4,a2
	bra	@f
__tputs_fntmd02_12:
	move.l	a1,a2
	lea	twin_pt12_zero+4,a1
	bra	@f
__tputs_fntmd03_12:
	move.l	a1,a2
@@:
	move.w	tcurx(a3),d0
	cmp.w	txmax(a3),d0
	bcs	@f
	bsr	_cur_crlf
@@:
	move.w	x(a6),d1
	move.w	d1,d0
	lsr.w	#3,d1

	move.l	a5,d5
	add.w	d1,a5
	move.l	a5,a0
	add.l	#$20000,a0

	and.w	#%1110,d0
	add.w	d0,d0

	jmp	__tputs_12_tbl(pc,d0.w)

__tputs_12_tbl:
	bra.w	__tputs_120
	bra.w	__tputs_123
	bra.w	__tputs_126
	bra.w	__tputs_121
	bra.w	__tputs_124
	bra.w	__tputs_127
	bra.w	__tputs_122
	bra.w	__tputs_125

__tputs_126:
	move.w	#%0000_1111_1111_1111,d2
	move.w	#%1111_0000_0000_0000,d4
	moveq.l	#4,d3
	bra	@f
__tputs_123:
	move.w	#%0011_1111_1111_1100,d2
	move.w	#%1100_0000_0000_0011,d4
	moveq.l	#2,d3
	bra	@f
__tputs_120:
	move.w	#%1111_1111_1111_0000,d2
	move.w	#%0000_0000_0000_1111,d4
	moveq.l	#0,d3
@@:
	movem.l	d5/a3,-(sp)
	move.w	#$0080,a3
	moveq.l	#12-1,d5
1:
	move.w	(a1)+,d0
	lsr.w	d3,d0
	and.w	d2,d0
	and.w	d4,(a5)
	or.w	d0,(a5)

	move.w	(a2)+,d0
	lsr.w	d3,d0
	and.w	d2,d0
	and.w	d4,(a0)
	or.w	d0,(a0)

	add.w	a3,a5
	add.w	a3,a0
	dbra	d5,1b
	movem.l	(sp)+,d5/a3

	move.l	d5,a5
	bsr	_cur_right2
	rts

__tputs_127:
	move.l	#%0000_0000_0011_1111_1111_1100_0000_0000,d2
	move.l	#%1111_1111_1100_0000_0000_0011_1111_1111,d4
	moveq.l	#6,d3
	bra	@f
__tputs_125:
	move.l	#%0000_0000_0000_0011_1111_1111_1100_0000,d2
	move.l	#%1111_1111_1111_1100_0000_0000_0011_1111,d4
	moveq.l	#2,d3
	bra	@f
__tputs_124:
	move.l	#%0000_0000_1111_1111_1111_0000_0000_0000,d2
	move.l	#%1111_1111_0000_0000_0000_1111_1111_1111,d4
	moveq.l	#8,d3
	bra	@f
__tputs_122:
	move.l	#%0000_0000_0000_1111_1111_1111_0000_0000,d2
	move.l	#%1111_1111_1111_0000_0000_0000_1111_1111,d4
	moveq.l	#4,d3
@@:
	subq.w	#1,a5
	subq.w	#1,a0

	movem.l	d5/a3,-(sp)
	move.w	#$0080,a3
	moveq.l	#12-1,d5
1:
	move.w	(a1)+,d0
	lsl.l	d3,d0
	and.l	d2,d0
	and.l	d4,(a5)
	or.l	d0,(a5)

	move.w	(a2)+,d0
	lsl.l	d3,d0
	and.l	d2,d0
	and.l	d4,(a0)
	or.l	d0,(a0)

	add.w	a3,a5
	add.w	a3,a0
	dbra	d5,1b
	movem.l	(sp)+,d5/a3

	move.l	d5,a5
	bsr	_cur_right2
	rts

__tputs_121:
	move.l	#%0000_0011_1111_1111_1100_0000_0000_0000,d2
	move.l	#%1111_1100_0000_0000_0011_1111_1111_1111,d4
	moveq.l	#6,d3

	movem.l	d5/a3,-(sp)
	move.w	#$0080,a3
	moveq.l	#12-1,d5
1:
	move.w	(a1)+,d0
	swap.w	d0
	lsr.l	d3,d0
	and.l	d2,d0
	and.l	d4,(a5)
	or.l	d0,(a5)

	move.w	(a2)+,d0
	swap.w	d0
	lsr.l	d3,d0
	and.l	d2,d0
	and.l	d4,(a0)
	or.l	d0,(a0)

	add.w	a3,a5
	add.w	a3,a0
	dbra	d5,1b
	movem.l	(sp)+,d5/a3

	move.l	d5,a5
	bsr	_cur_right2
	rts


__tputs_fntmd00_12_24:
	lea	twin_pt12_24_zero+4,a1
	move.l	a1,a2
	bra	@f
__tputs_fntmd01_12_24:
	lea	twin_pt12_24_zero+4,a2
	bra	@f
__tputs_fntmd02_12_24:
	move.l	a1,a2
	lea	twin_pt12_24_zero+4,a1
	bra	@f
__tputs_fntmd03_12_24:
	move.l	a1,a2
@@:
	move.w	tcurx(a3),d0
	cmp.w	txmax(a3),d0
	bls	@f
	bsr	_cur_crlf
@@:
	move.w	x(a6),d1
	move.w	d1,d0
	lsr.w	#3,d1

	move.l	a5,d5
	add.w	d1,a5
	move.l	a5,a0
	add.l	#$20000,a0

	and.w	#%1110,d0
	add.w	d0,d0

	jmp	__tputs_12_24_tbl(pc,d0.w)

__tputs_12_24_tbl:
	bra.w	__tputs_12_240
	bra.w	__tputs_12_nop
	bra.w	__tputs_12_246
	bra.w	__tputs_12_nop
	bra.w	__tputs_12_244
	bra.w	__tputs_12_nop
	bra.w	__tputs_12_242
	bra.w	__tputs_12_nop

__tputs_12_nop:
	rts

__tputs_12_246:
	move.w	#%0000_1111_1111_1111,d2
	move.w	#%1111_0000_0000_0000,d4
	moveq.l	#4,d3
	bra	@f
__tputs_12_243:
	move.w	#%0011_1111_1111_1100,d2
	move.w	#%1100_0000_0000_0011,d4
	moveq.l	#2,d3
	bra	@f
__tputs_12_240:
	move.w	#%1111_1111_1111_0000,d2
	move.w	#%0000_0000_0000_1111,d4
	moveq.l	#0,d3
@@:
	movem.l	d5/a3,-(sp)
	move.w	#$0080,a3
	moveq.l	#24-1,d5
1:
	move.w	(a1)+,d0
	lsr.w	d3,d0
	and.w	d2,d0
	and.w	d4,(a5)
	or.w	d0,(a5)

	move.w	(a2)+,d0
	lsr.w	d3,d0
	and.w	d2,d0
	and.w	d4,(a0)
	or.w	d0,(a0)

	add.w	a3,a5
	add.w	a3,a0
	dbra	d5,1b
	movem.l	(sp)+,d5/a3

	move.l	d5,a5
	bsr	_cur_right
	rts

__tputs_12_247:
	move.l	#%0000_0000_0011_1111_1111_1100_0000_0000,d2
	move.l	#%1111_1111_1100_0000_0000_0011_1111_1111,d4
	moveq.l	#6,d3
	bra	@f
__tputs_12_245:
	move.l	#%0000_0000_0000_0011_1111_1111_1100_0000,d2
	move.l	#%1111_1111_1111_1100_0000_0000_0011_1111,d4
	moveq.l	#2,d3
	bra	@f
__tputs_12_244:
	move.l	#%0000_0000_1111_1111_1111_0000_0000_0000,d2
	move.l	#%1111_1111_0000_0000_0000_1111_1111_1111,d4
	moveq.l	#8,d3
	bra	@f
__tputs_12_242:
	move.l	#%0000_0000_0000_1111_1111_1111_0000_0000,d2
	move.l	#%1111_1111_1111_0000_0000_0000_1111_1111,d4
	moveq.l	#4,d3
@@:
	subq.w	#1,a5
	subq.w	#1,a0

	movem.l	d5/a3,-(sp)
	move.w	#$0080,a3
	moveq.l	#24-1,d5
1:
	move.w	(a1)+,d0
	lsl.l	d3,d0
	and.l	d2,d0
	and.l	d4,(a5)
	or.l	d0,(a5)

	move.w	(a2)+,d0
	lsl.l	d3,d0
	and.l	d2,d0
	and.l	d4,(a0)
	or.l	d0,(a0)

	add.w	a3,a5
	add.w	a3,a0
	dbra	d5,1b
	movem.l	(sp)+,d5/a3

	move.l	d5,a5
	bsr	_cur_right
	rts

__tputs_12_241:
	move.l	#%0000_0011_1111_1111_1100_0000_0000_0000,d2
	move.l	#%1111_1100_0000_0000_0011_1111_1111_1111,d4
	moveq.l	#6,d3

	movem.l	d5/a3,-(sp)
	move.w	#$0080,a3
	moveq.l	#24-1,d5
1:
	move.w	(a1)+,d0
	swap.w	d0
	lsr.l	d3,d0
	and.l	d2,d0
	and.l	d4,(a5)
	or.l	d0,(a5)

	move.w	(a2)+,d0
	swap.w	d0
	lsr.l	d3,d0
	and.l	d2,d0
	and.l	d4,(a0)
	or.l	d0,(a0)

	add.w	a3,a5
	add.w	a3,a0
	dbra	d5,1b
	movem.l	(sp)+,d5/a3

	move.l	d5,a5
	bsr	_cur_right
	rts


__tputs_fntmd00_24:
	lea	twin_pt24_zero+4,a1
	move.l	a1,a2
	bra	@f
__tputs_fntmd01_24:
	lea	twin_pt24_zero+4,a2
	bra	@f
__tputs_fntmd02_24:
	move.l	a1,a2
	lea	twin_pt24_zero+4,a1
	bra	@f
__tputs_fntmd03_24:
	move.l	a1,a2
@@:
	move.w	tcurx(a3),d0
	cmp.w	txmax(a3),d0
	bcs	@f
	bsr	_cur_crlf
@@:
	move.w	x(a6),d1
	move.w	d1,d0
	lsr.w	#3,d1

	move.l	a5,d5
	add.w	d1,a5
	move.l	a5,a0
	add.l	#$20000,a0

	and.w	#%1110,d0
	add.w	d0,d0

	jmp	__tputs_24_tbl(pc,d0.w)

__tputs_24_tbl:
	bra.w	__tputs_240
	bra.w	__tputs_24_nop
	bra.w	__tputs_246
	bra.w	__tputs_24_nop
	bra.w	__tputs_244
	bra.w	__tputs_24_nop
	bra.w	__tputs_242
	bra.w	__tputs_24_nop

__tputs_24_nop:
	rts

__tputs_240:
	movem.l	d5/a3,-(sp)
	move.w	#$0080,a3
	moveq.l	#12-1,d5
1:
	move.w	(a1)+,(a5)
	move.b	(a1)+,2(a5)
	move.w	(a2)+,(a0)
	move.b	(a2)+,2(a0)

	add.w	a3,a5
	add.w	a3,a0

	move.b	(a1)+,(a5)
	move.b	(a1)+,1(a5)
	move.b	(a1)+,2(a5)
	move.b	(a2)+,(a0)
	move.b	(a2)+,1(a0)
	move.b	(a2)+,2(a0)

	add.w	a3,a5
	add.w	a3,a0
	dbra	d5,1b
	movem.l	(sp)+,d5/a3

	move.l	d5,a5
	bsr	_cur_right2
	rts

__tputs_242:
	move.l	#%0000_0000_0000_1111_1111_1111_1111_0000,d2
	move.l	#%1111_1111_1111_0000_0000_0000_0000_1111,d4

	move.l	#%0000_0000_0000_1111_1111_0000_0000_0000,d1
	move.l	#%1111_1111_1111_0000_0000_1111_1111_1111,d3

	subq.w	#1,a5
	subq.w	#1,a0

	movem.l	d5/a3,-(sp)
	move.w	#$0080,a3
	moveq.l	#12-1,d5
1:
	move.w	(a1)+,d0
	lsl.l	#4,d0
	and.l	d2,d0
	and.l	d4,(a5)
	or.l	d0,(a5)

	move.b	(a1)+,d0
	swap.w	d0
	lsr.l	#4,d0
	and.l	d1,d0
	and.l	d3,2(a5)
	or.l	d0,2(a5)

	move.w	(a2)+,d0
	lsl.l	#4,d0
	and.l	d2,d0
	and.l	d4,(a0)
	or.l	d0,(a0)

	move.b	(a2)+,d0
	swap.w	d0
	lsr.l	#4,d0
	and.l	d1,d0
	and.l	d3,2(a0)
	or.l	d0,2(a0)

	add.w	a3,a5
	add.w	a3,a0

	move.b	(a1)+,d0
	swap.w	d0
	move.w	(a1)+,d0
	lsr.l	#4,d0
	and.l	d2,d0
	and.l	d4,(a5)
	or.l	d0,(a5)

	move.b	-1(a1),d0
	swap.w	d0
	lsr.l	#4,d0
	and.l	d1,d0
	and.l	d3,2(a5)
	or.l	d0,2(a5)

	move.b	(a2)+,d0
	swap.w	d0
	move.w	(a2)+,d0
	lsr.l	#4,d0
	and.l	d2,d0
	and.l	d4,(a0)
	or.l	d0,(a0)

	move.b	-1(a2),d0
	swap.w	d0
	lsr.l	#4,d0
	and.l	d1,d0
	and.l	d3,2(a0)
	or.l	d0,2(a0)

	add.w	a3,a5
	add.w	a3,a0
	dbra	d5,1b
	movem.l	(sp)+,d5/a3

	move.l	d5,a5
	bsr	_cur_right2
	rts

__tputs_244:
	movem.l	d5/a3,-(sp)
	move.w	#$0080,a3
	moveq.l	#12-1,d5
1:
	move.b	(a1)+,(a5)
	move.b	(a1)+,1(a5)
	move.b	(a1)+,2(a5)

	move.b	(a2)+,(a0)
	move.b	(a2)+,1(a0)
	move.b	(a2)+,2(a0)

	add.w	a3,a5
	add.w	a3,a0

	move.b	(a1)+,(a5)
	move.w	(a1)+,1(a5)

	move.b	(a2)+,(a0)
	move.w	(a2)+,1(a0)

	add.w	a3,a5
	add.w	a3,a0
	dbra	d5,1b
	movem.l	(sp)+,d5/a3

	move.l	d5,a5
	bsr	_cur_right2
	rts

__tputs_246:
	move.l	#%0000_1111_1111_1111_1111_0000_0000_0000,d2
	move.l	#%1111_0000_0000_0000_0000_1111_1111_1111,d4

	move.w	#%0000_1111_1111_0000,d1
	move.w	#%1111_0000_0000_1111,d3

	movem.l	d5/a3,-(sp)
	move.w	#$0080,a3
	moveq.l	#12-1,d5
1:
	move.w	(a1)+,d0
	swap.w	d0
	lsr.l	#4,d0
	and.l	d2,d0
	and.l	d4,(a5)
	or.l	d0,(a5)

	move.b	(a1)+,d0
	lsl.w	#4,d0
	and.w	d1,d0
	and.w	d3,2(a5)
	or.w	d0,2(a5)

	move.w	(a2)+,d0
	swap.w	d0
	lsr.l	#4,d0
	and.l	d2,d0
	and.l	d4,(a0)
	or.l	d0,(a0)

	move.b	(a2)+,d0
	lsl.w	#4,d0
	and.w	d1,d0
	and.w	d3,2(a0)
	or.w	d0,2(a0)

	add.w	a3,a5
	add.w	a3,a0

	move.b	(a1)+,d0
	swap.w	d0
	move.w	(a1)+,d0
	lsl.l	#4,d0
	and.l	d2,d0
	and.l	d4,(a5)
	or.l	d0,(a5)

	move.b	-1(a1),d0
	lsl.w	#4,d0
	and.w	d1,d0
	and.w	d3,2(a5)
	or.w	d0,2(a5)

	move.b	(a2)+,d0
	swap.w	d0
	move.w	(a2)+,d0
	lsl.l	#4,d0
	and.l	d2,d0
	and.l	d4,(a0)
	or.l	d0,(a0)

	move.b	-1(a2),d0
	lsl.w	#4,d0
	and.w	d1,d0
	and.w	d3,2(a0)
	or.w	d0,2(a0)

	add.w	a3,a5
	add.w	a3,a0
	dbra	d5,1b
	movem.l	(sp)+,d5/a3

	move.l	d5,a5
	bsr	_cur_right2
	rts




__tputs_fntmd10_8:
	pea	__tputs_fntmd00_8(pc)
	bra	@f
__tputs_fntmd11_8:
	pea	__tputs_fntmd01_8(pc)
	bra	@f
__tputs_fntmd12_8:
	pea	__tputs_fntmd02_8(pc)
	bra	@f
__tputs_fntmd13_8:
	pea	__tputs_fntmd03_8(pc)
@@:
	move.l	a1,a0
	lea	fnt_work+4(a6),a1
	move.l	a1,a2
	moveq.l	#4-1,d1
	move.l	#$7f7f7f7f,d2

__tputs_fntmd1:
	move.l	(a0)+,d0
	move.l	d0,d5
	lsr.l	#1,d0
	and.l	d2,d0
	or.l	d5,d0
	move.l	d0,(a2)+
	dbra	d1,__tputs_fntmd1
	rts


__tputs_fntmd10_16:
	pea	__tputs_fntmd00_16(pc)
	bra	@f
__tputs_fntmd11_16:
	pea	__tputs_fntmd01_16(pc)
	bra	@f
__tputs_fntmd12_16:
	pea	__tputs_fntmd02_16(pc)
	bra	@f
__tputs_fntmd13_16:
	pea	__tputs_fntmd03_16(pc)
@@:
	move.l	a1,a0
	lea	fnt_work+4(a6),a1
	move.l	a1,a2
	moveq.l	#8-1,d1
	move.l	#$7fff7fff,d2

	bra	__tputs_fntmd1


__tputs_fntmd10_6:
	pea	__tputs_fntmd00_6(pc)
	bra	@f
__tputs_fntmd11_6:
	pea	__tputs_fntmd01_6(pc)
	bra	@f
__tputs_fntmd12_6:
	pea	__tputs_fntmd02_6(pc)
	bra	@f
__tputs_fntmd13_6:
	pea	__tputs_fntmd03_6(pc)
@@:
	move.l	a1,a0
	lea	fnt_work+4(a6),a1
	move.l	a1,a2
	moveq.l	#3-1,d1
	move.l	#$fcfcfcfc,d2

	bra	__tputs_fntmd1


__tputs_fntmd10_12:
	pea	__tputs_fntmd00_12(pc)
	bra	@f
__tputs_fntmd11_12:
	pea	__tputs_fntmd01_12(pc)
	bra	@f
__tputs_fntmd12_12:
	pea	__tputs_fntmd02_12(pc)
	bra	@f
__tputs_fntmd13_12:
	pea	__tputs_fntmd03_12(pc)
@@:
	move.l	a1,a0
	lea	fnt_work+4(a6),a1
	move.l	a1,a2
	moveq.l	#6-1,d1
	move.l	#$fff0fff0,d2

	bra	__tputs_fntmd1


__tputs_fntmd10_12_24:
	pea	__tputs_fntmd00_12_24(pc)
	bra	@f
__tputs_fntmd11_12_24:
	pea	__tputs_fntmd01_12_24(pc)
	bra	@f
__tputs_fntmd12_12_24:
	pea	__tputs_fntmd02_12_24(pc)
	bra	@f
__tputs_fntmd13_12_24:
	pea	__tputs_fntmd03_12_24(pc)
@@:
	move.l	a1,a0
	lea	fnt_work+4(a6),a1
	move.l	a1,a2
	moveq.l	#12-1,d1
	move.l	#$fff0fff0,d2

	bra	__tputs_fntmd1


__tputs_fntmd10_24:
	pea	__tputs_fntmd00_24(pc)
	bra	@f
__tputs_fntmd11_24:
	pea	__tputs_fntmd01_24(pc)
	bra	@f
__tputs_fntmd12_24:
	pea	__tputs_fntmd02_24(pc)
	bra	@f
__tputs_fntmd13_24:
	pea	__tputs_fntmd03_24(pc)
@@:
	move.l	a1,a0
	lea	fnt_work+4(a6),a1
	move.l	a1,a2
	moveq.l	#12-1,d1
	move.l	#$7fff_ff7f,d2

__tputs_fntmd1_24:
	move.l	(a0)+,d0
	move.l	d0,d5
	lsr.l	#1,d0
	and.l	d2,d0
	or.l	d5,d0
	move.l	d0,(a2)+

	move.w	(a0)+,d0
	move.w	d0,d5
	roxr.w	#1,d5
	or.w	d5,d0
	move.w	d0,(a2)+
	dbra	d1,__tputs_fntmd1_24
	rts



__tputs_fntmd20_8:
	pea	__tputs_fntmd00_8(pc)
	bra	@f
__tputs_fntmd21_8:
	pea	__tputs_fntmd01_8(pc)
	bra	@f
__tputs_fntmd22_8:
	pea	__tputs_fntmd02_8(pc)
	bra	@f
__tputs_fntmd23_8:
	pea	__tputs_fntmd03_8(pc)
@@:
	move.l	a1,a0
	lea	fnt_work+4(a6),a1
	move.l	a1,a2
	moveq.l	#4-1,d1
	moveq.l	#-1,d2

__tputs_fntmd2:
	move.l	(a0)+,d0
	eor.l	d2,d0
	move.l	d0,(a2)+
	dbra	d1,__tputs_fntmd2
	rts


__tputs_fntmd20_16:
	pea	__tputs_fntmd00_16(pc)
	bra	@f
__tputs_fntmd21_16:
	pea	__tputs_fntmd01_16(pc)
	bra	@f
__tputs_fntmd22_16:
	pea	__tputs_fntmd02_16(pc)
	bra	@f
__tputs_fntmd23_16:
	pea	__tputs_fntmd03_16(pc)
@@:
	move.l	a1,a0
	lea	fnt_work+4(a6),a1
	move.l	a1,a2
	moveq.l	#8-1,d1
	moveq.l	#-1,d2

	bra	__tputs_fntmd2


__tputs_fntmd20_6:
	pea	__tputs_fntmd00_6(pc)
	bra	@f
__tputs_fntmd21_6:
	pea	__tputs_fntmd01_6(pc)
	bra	@f
__tputs_fntmd22_6:
	pea	__tputs_fntmd02_6(pc)
	bra	@f
__tputs_fntmd23_6:
	pea	__tputs_fntmd03_6(pc)
@@:
	move.l	a1,a0
	lea	fnt_work+4(a6),a1
	move.l	a1,a2
	moveq.l	#3-1,d1
	move.l	#$fcfcfcfc,d2

	bra	__tputs_fntmd2


__tputs_fntmd20_12:
	pea	__tputs_fntmd00_12(pc)
	bra	@f
__tputs_fntmd21_12:
	pea	__tputs_fntmd01_12(pc)
	bra	@f
__tputs_fntmd22_12:
	pea	__tputs_fntmd02_12(pc)
	bra	@f
__tputs_fntmd23_12:
	pea	__tputs_fntmd03_12(pc)
@@:
	move.l	a1,a0
	lea	fnt_work+4(a6),a1
	move.l	a1,a2
	moveq.l	#6-1,d1
	move.l	#$fff0fff0,d2

	bra	__tputs_fntmd2


__tputs_fntmd20_12_24:
	pea	__tputs_fntmd00_12_24(pc)
	bra	@f
__tputs_fntmd21_12_24:
	pea	__tputs_fntmd01_12_24(pc)
	bra	@f
__tputs_fntmd22_12_24:
	pea	__tputs_fntmd02_12_24(pc)
	bra	@f
__tputs_fntmd23_12_24:
	pea	__tputs_fntmd03_12_24(pc)
@@:
	move.l	a1,a0
	lea	fnt_work+4(a6),a1
	move.l	a1,a2
	moveq.l	#12-1,d1
	move.l	#$fff0fff0,d2

	bra	__tputs_fntmd2


__tputs_fntmd20_24:
	pea	__tputs_fntmd00_24(pc)
	bra	@f
__tputs_fntmd21_24:
	pea	__tputs_fntmd01_24(pc)
	bra	@f
__tputs_fntmd22_24:
	pea	__tputs_fntmd02_24(pc)
	bra	@f
__tputs_fntmd23_24:
	pea	__tputs_fntmd03_24(pc)
@@:
	move.l	a1,a0
	lea	fnt_work+4(a6),a1
	move.l	a1,a2
	moveq.l	#12-1,d1

__tputs_fntmd2_24:
	move.l	(a0)+,d0
	not.l	d0
	move.l	d0,(a2)+
	move.w	(a0)+,d0
	not.w	d0
	move.w	d0,(a2)+
	dbra	d1,__tputs_fntmd2_24
	rts



__tputs_fntmd30_8:
	pea	__tputs_fntmd00_8(pc)
	bra	@f
__tputs_fntmd31_8:
	pea	__tputs_fntmd01_8(pc)
	bra	@f
__tputs_fntmd32_8:
	pea	__tputs_fntmd02_8(pc)
	bra	@f
__tputs_fntmd33_8:
	pea	__tputs_fntmd03_8(pc)
@@:
	move.l	a1,a0
	lea	fnt_work+4(a6),a1
	move.l	a1,a2
	moveq.l	#4-1,d1
	move.l	#$7f7f7f7f,d2

__tputs_fntmd3_8:
	move.l	(a0)+,d0
	move.l	d0,d5
	lsr.l	#1,d0
	and.l	d2,d0
	or.l	d5,d0
	not.l	d0
	move.l	d0,(a2)+
	dbra	d1,__tputs_fntmd3_8
	rts


__tputs_fntmd30_16:
	pea	__tputs_fntmd00_16(pc)
	bra	@f
__tputs_fntmd31_16:
	pea	__tputs_fntmd01_16(pc)
	bra	@f
__tputs_fntmd32_16:
	pea	__tputs_fntmd02_16(pc)
	bra	@f
__tputs_fntmd33_16:
	pea	__tputs_fntmd03_16(pc)
@@:
	move.l	a1,a0
	lea	fnt_work+4(a6),a1
	move.l	a1,a2
	moveq.l	#8-1,d1
	move.l	#$7fff7fff,d2

	bra	__tputs_fntmd3_8


__tputs_fntmd30_6:
	pea	__tputs_fntmd00_6(pc)
	bra	@f
__tputs_fntmd31_6:
	pea	__tputs_fntmd01_6(pc)
	bra	@f
__tputs_fntmd32_6:
	pea	__tputs_fntmd02_6(pc)
	bra	@f
__tputs_fntmd33_6:
	pea	__tputs_fntmd03_6(pc)
@@:
	move.l	a1,a0
	lea	fnt_work+4(a6),a1
	move.l	a1,a2
	moveq.l	#3-1,d1
	move.l	#$fcfcfcfc,d2

__tputs_fntmd3_6:
	move.l	(a0)+,d0
	move.l	d0,d0
	lsr.l	#1,d0
	and.l	d2,d0
	or.l	d5,d0
	eor.l	d2,d0
	move.l	d0,(a2)+
	dbra	d1,__tputs_fntmd3_6
	rts


__tputs_fntmd30_12:
	pea	__tputs_fntmd00_12(pc)
	bra	@f
__tputs_fntmd31_12:
	pea	__tputs_fntmd01_12(pc)
	bra	@f
__tputs_fntmd32_12:
	pea	__tputs_fntmd02_12(pc)
	bra	@f
__tputs_fntmd33_12:
	pea	__tputs_fntmd03_12(pc)
@@:
	move.l	a1,a0
	lea	fnt_work+4(a6),a1
	move.l	a1,a2
	moveq.l	#6-1,d1
	move.l	#$fff0fff0,d2

	bra	__tputs_fntmd3_6


__tputs_fntmd30_12_24:
	pea	__tputs_fntmd00_12_24(pc)
	bra	@f
__tputs_fntmd31_12_24:
	pea	__tputs_fntmd01_12_24(pc)
	bra	@f
__tputs_fntmd32_12_24:
	pea	__tputs_fntmd02_12_24(pc)
	bra	@f
__tputs_fntmd33_12_24:
	pea	__tputs_fntmd03_12_24(pc)
@@:
	move.l	a1,a0
	lea	fnt_work+4(a6),a1
	move.l	a1,a2
	moveq.l	#12-1,d1
	move.l	#$fff0fff0,d2

	bra	__tputs_fntmd3_6


__tputs_fntmd30_24:
	pea	__tputs_fntmd00_24(pc)
	bra	@f
__tputs_fntmd31_24:
	pea	__tputs_fntmd01_24(pc)
	bra	@f
__tputs_fntmd32_24:
	pea	__tputs_fntmd02_24(pc)
	bra	@f
__tputs_fntmd33_24:
	pea	__tputs_fntmd03_24(pc)
@@:
	move.l	a1,a0
	moveq.l	#12-1,d1
	move.l	#$7fff_ff7f,d2

__tputs_fntmd3_24:
	move.l	(a0)+,d0
	move.l	d0,d5
	lsr.l	#1,d0
	and.l	d2,d0
	or.l	d5,d0
	not.l	d0
	move.l	d0,(a2)+
	move.w	(a0)+,d0
	move.w	d0,d5
	roxr.w	#1,d0
	or.w	d5,d0
	not.w	d0
	move.w	d0,(a2)+
	dbra	d1,__tputs_fntmd3_24
	rts



_cury_calc:
	move.w	ty(a3),d0
	addq.w	#1,d0
	add.w	tys(a3),d0
	add.w	tcury(a3),d0
	move.w	d0,posy(a6)

	mulu.w	d6,d0
	add.w	d0,d0			* d0 = ΂xW
	move.w	d0,y(a6)
	lsl.l	#7,d0
	move.l	tvram(a3),a5
	add.l	d0,a5			* a5 = eLXgxW擪
	rts

_curx_calc:
	move.w	tx(a3),d0
	addq.w	#1,d0
	add.w	txs(a3),d0
	add.w	tcurx(a3),d0
	move.w	d0,posx(a6)

	mulu.w	d6,d0			* d0 = ΂wW
	move.w	d0,x(a6)
	rts

_cur_right:
	addq.w	#1,tcurx(a3)
	addq.w	#1,posx(a6)
	add.w	d6,x(a6)
	rts

_cur_right2:
	addq.w	#2,tcurx(a3)
	addq.w	#2,posx(a6)
	add.w	d6,x(a6)
	add.w	d6,x(a6)
	rts

_cur_crlf:
	clr.w	tcurx(a3)	* A
	bsr	_curx_calc
	bsr	_cur_down	* s
	rts

_cur_home:
	clr.w	tcurx(a3)
	clr.w	tcury(a3)
	bsr	_curx_calc
	bsr	_cury_calc
	rts

_cur_down:
	move.w	tcury(a3),d0
	addq.w	#1,d0
	cmp.w	tymax(a3),d0
	bls	@f
	bra	_scroll_up
@@:
	move.w	d0,tcury(a3)
	bsr	_cury_calc
	rts

_scroll_up:
	tst.w	tscmod(a3)
	bne	_scroll_up2
	tst.w	tymax(a3)
	beq	_scroll_clr

	movem.l	d1-d5,-(sp)
	move.w	tx(a3),d1
	addq.w	#1,d1
	add.w	txs(a3),d1
	mulu.w	d6,d1
	move.w	ty(a3),d2
	addq.w	#1,d2
	add.w	tys(a3),d2
	move.w	d2,d5
	addq.w	#1,d2		* Ps
	mulu.w	tfsize(a3),d2
	mulu.w	tfsize(a3),d5

	move.w	txmax(a3),d3
	addq.w	#1,d3
	mulu.w	d6,d3
	move.w	tymax(a3),d4
	mulu.w	tfsize(a3),d4

	move.l	tvram(a3),a1	* uq`lAhX

	jsr	__tycopy	* Rs[

	move.w	ty(a3),d2
	addq.w	#1,d2
	add.w	tys(a3),d2
	add.w	tymax(a3),d2
	mulu.w	tfsize(a3),d2
	move.w	tfsize(a3),d4

	jsr	__tclr3		* PsNA

	movem.l	(sp)+,d1-d5
	rts

_scroll_clr:			* XN[͈͂Ps̎...
	movem.l	d1-d4,-(sp)
	move.w	tx(a3),d1
	addq.w	#1,d1
	add.w	txs(a3),d1
	mulu.w	d6,d1
	move.w	ty(a3),d2
	addq.w	#1,d2
	add.w	tys(a3),d2
	mulu.w	tfsize(a3),d2

	move.w	txmax(a3),d3
	addq.w	#1,d3
	mulu.w	d6,d3
	move.w	tymax(a3),d4
	addq.w	#1,d4
	mulu.w	tfsize(a3),d4

	move.l	tvram(a3),a1	* uq`lAhX

	jsr	__tclr3		* NA

	movem.l	(sp)+,d1-d4
	rts

_scroll_down:
	tst.w	tscmod(a3)
	bne	_scroll_down2
	tst.w	tymax(a3)
	beq	_scroll_clr

	movem.l	d1-d5,-(sp)
	move.w	tx(a3),d1
	addq.w	#1,d1
	add.w	txs(a3),d1
	mulu.w	d6,d1
	move.w	ty(a3),d2
	addq.w	#1,d2
	add.w	tys(a3),d2
	add.w	tymax(a3),d2
	move.w	d2,d5
	addq.w	#1,d5
	mulu.w	tfsize(a3),d2
	mulu.w	tfsize(a3),d5
	subq.w	#1,d2
	subq.w	#1,d5
	bset.l	#15,d5

	move.w	txmax(a3),d3
	addq.w	#1,d3
	mulu.w	d6,d3
	move.w	tymax(a3),d4
	mulu.w	tfsize(a3),d4

	move.l	tvram(a3),a1	* uq`lAhX

	jsr	__tycopy	* Rs[

	move.w	ty(a3),d2
	addq.w	#1,d2
	add.w	tys(a3),d2
	mulu.w	tfsize(a3),d2
	move.w	tfsize(a3),d4

	jsr	__tclr3		* PsNA

	movem.l	(sp)+,d1-d5
	rts

	.offset	-(2*2)
_scroll2_link_start:
_sc_y:		.ds.w	1
_sc_ysize:	.ds.w	1
	.text

_scroll_up2:
	link	a6,#_scroll2_link_start
	movem.l	d1-d7,-(sp)
	move.w	tx(a3),d1
	addq.w	#1,d1
	add.w	txs(a3),d1
	mulu.w	d6,d1
	move.w	ty(a3),d2
	addq.w	#1,d2
	add.w	tys(a3),d2
	move.w	d2,d5
	mulu.w	tfsize(a3),d2
	mulu.w	tfsize(a3),d5
	addq.w	#2,d2		* 2 line

	move.w	txmax(a3),d3
	addq.w	#1,d3
	mulu.w	d6,d3
	move.w	tymax(a3),d4
	addq.w	#1,d4
	mulu.w	tfsize(a3),d4
	subq.w	#2,d4

	move.w	d2,_sc_y(a6)
	move.w	d4,_sc_ysize(a6)

	move.w	ty(a3),d7
	addq.w	#1,d7
	add.w	tys(a3),d7
	add.w	tymax(a3),d7
	addq.w	#1,d7
	mulu.w	tfsize(a3),d7
	subq.w	#2,d7

	move.w	tfsize(a3),d6
	lsr.w	#1,d6
	subq.w	#2,d6

*@@:
*	btst.b	#4,$e88001
*	bne	@b

	move.l	tvram(a3),a1	* uq`lAhX

	jsr	__tycopy	* 2 line Rs[
	move.w	d7,d2
	moveq.l	#2,d4
	jsr	__tclr3		* 2 line NA
	move.w	_sc_y(a6),d2
	move.w	_sc_ysize(a6),d4
_scroll_up2_loop:
*@@:
*	btst.b	#4,$e88001
*	bne	@b

	jsr	__tycopy	* 2 line Rs[
	dbra	d6,_scroll_up2_loop

	movem.l	(sp)+,d1-d7
	unlk	a6
	rts


_scroll_down2:
	link	a6,#_scroll2_link_start
	movem.l	d1-d7,-(sp)
	move.w	tx(a3),d1
	addq.w	#1,d1
	add.w	txs(a3),d1
	mulu.w	d6,d1
	move.w	ty(a3),d2
	addq.w	#1,d2
	add.w	tys(a3),d2
	add.w	tymax(a3),d2
	addq.w	#1,d2
	move.w	d2,d5
	mulu.w	tfsize(a3),d2
	mulu.w	tfsize(a3),d5
	subq.w	#3,d2
	subq.w	#1,d5
	bset.l	#15,d5

	move.w	txmax(a3),d3
	addq.w	#1,d3
	mulu.w	d6,d3
	move.w	tymax(a3),d4
	addq.w	#1,d4
	mulu.w	tfsize(a3),d4
	subq.w	#2,d4

	move.w	d2,_sc_y(a6)
	move.w	d4,_sc_ysize(a6)

	move.w	ty(a3),d7
	addq.w	#1,d7
	add.w	tys(a3),d7
	mulu.w	tfsize(a3),d7

	move.w	tfsize(a3),d6
	lsr.w	#1,d6
	subq.w	#2,d6

*@@:
*	btst.b	#4,$e88001
*	bne	@b

	move.l	tvram(a3),a1	* uq`lAhX

	jsr	__tycopy	* 2 line Rs[
	move.w	d7,d2
	moveq.l	#2,d4
	jsr	__tclr3		* 2 line NA
	move.w	_sc_y(a6),d2
	move.w	_sc_ysize(a6),d4
_scroll_down2_loop:
*@@:
*	btst.b	#4,$e88001
*	bne	@b

	jsr	__tycopy	* 2 line Rs[
	dbra	d6,_scroll_down2_loop

	movem.l	(sp)+,d1-d7
	unlk	a6
	rts



__tputs_ctrl_sub:
	add.w	d1,d1
	move.w	__tputs_ctrl_tbl(pc,d1.w),d0
	jsr	__tputs_ctrl_tbl(pc,d0.w)
	rts

__tputs_ctrl_tbl:
	dc.w	_ctrl_00-__tputs_ctrl_tbl
	dc.w	_ctrl_01-__tputs_ctrl_tbl
	dc.w	_ctrl_02-__tputs_ctrl_tbl
	dc.w	_ctrl_03-__tputs_ctrl_tbl
	dc.w	_ctrl_04-__tputs_ctrl_tbl
	dc.w	_ctrl_05-__tputs_ctrl_tbl
	dc.w	_ctrl_06-__tputs_ctrl_tbl
	dc.w	_ctrl_07-__tputs_ctrl_tbl
	dc.w	_ctrl_08-__tputs_ctrl_tbl
	dc.w	_ctrl_09-__tputs_ctrl_tbl
	dc.w	_ctrl_0A-__tputs_ctrl_tbl
	dc.w	_ctrl_0B-__tputs_ctrl_tbl
	dc.w	_ctrl_0C-__tputs_ctrl_tbl
	dc.w	_ctrl_0D-__tputs_ctrl_tbl
	dc.w	_ctrl_0E-__tputs_ctrl_tbl
	dc.w	_ctrl_0F-__tputs_ctrl_tbl
	dc.w	_ctrl_10-__tputs_ctrl_tbl
	dc.w	_ctrl_11-__tputs_ctrl_tbl
	dc.w	_ctrl_12-__tputs_ctrl_tbl
	dc.w	_ctrl_13-__tputs_ctrl_tbl
	dc.w	_ctrl_14-__tputs_ctrl_tbl
	dc.w	_ctrl_15-__tputs_ctrl_tbl
	dc.w	_ctrl_16-__tputs_ctrl_tbl
	dc.w	_ctrl_17-__tputs_ctrl_tbl
	dc.w	_ctrl_18-__tputs_ctrl_tbl
	dc.w	_ctrl_19-__tputs_ctrl_tbl
	dc.w	_ctrl_1A-__tputs_ctrl_tbl
	dc.w	_ctrl_1B-__tputs_ctrl_tbl
	dc.w	_ctrl_1C-__tputs_ctrl_tbl
	dc.w	_ctrl_1D-__tputs_ctrl_tbl
	dc.w	_ctrl_1E-__tputs_ctrl_tbl
	dc.w	_ctrl_1F-__tputs_ctrl_tbl

_ctrl_00:
_ctrl_01:
_ctrl_02:
_ctrl_03:
_ctrl_04:
_ctrl_05:
_ctrl_06:
*_ctrl_07:
*_ctrl_08:
*_ctrl_09:
*_ctrl_0A:
*_ctrl_0B:
*_ctrl_0C:
*_ctrl_0D:
_ctrl_0E:
_ctrl_0F:
_ctrl_10:
_ctrl_11:
_ctrl_12:
_ctrl_13:
_ctrl_14:
_ctrl_15:
_ctrl_16:
_ctrl_17:
_ctrl_18:
_ctrl_19:
*_ctrl_1A:
*_ctrl_1B:
_ctrl_1C:
_ctrl_1D:
*_ctrl_1E:
_ctrl_1F:
	rts

_ctrl_07:
* BEL
	rts

_ctrl_08:
* BS
	subq.w	#1,tcurx(a3)
	bpl	1f

	move.w	txmax(a3),tcurx(a3)
	subq.w	#1,tcury(a3)
	bpl	2f

	bsr	_cur_home	* J[\HOMEʒuɖ߂
	rts

2:
	subq.w	#1,posy(a6)
	moveq.l	#0,d0
	move.w	tfsize(a3),d0
	sub.w	d0,y(a6)
	lsl.l	#7,d0
	sub.l	d0,a5
	bsr	_curx_calc
	rts

1:
	subq.w	#1,posx(a6)
	sub.w	d6,x(a6)
	rts

_ctrl_09:
* HT
	move.w	tcurx(a3),d0
	cmp.w	txmax(a3),d0
	bls	@f
	bsr	_cur_crlf
	moveq.l	#0,d0
@@:
	addq.w	#8,d0
	and.w	#$fff8,d0
	cmp.w	txmax(a3),d0
	bls	@f
	bsr	_cur_crlf
	rts

@@:
	move.w	d0,tcurx(a3)
	bsr	_curx_calc
	rts

_ctrl_0A:
* LF
	move.w	tcurx(a3),d0
	cmp.w	txmax(a3),d0
	bls	@f
	bsr	_cur_crlf
@@:
	bsr	_cur_down
	rts

_ctrl_0B:
* VT
	move.w	tcurx(a3),d0
	cmp.w	txmax(a3),d0
	bls	@f
	bsr	_cur_crlf
@@:
	tst.w	tcury(a3)
	beq	@f
	subq.w	#1,tcury(a3)
	subq.w	#1,posy(a6)
	moveq.l	#0,d0
	move.w	tfsize(a3),d0
	sub.w	d0,y(a6)
	lsl.l	#7,d0
	sub.l	d0,a5
@@:
	rts

_ctrl_0C:
* FF
	move.w	tcurx(a3),d0
	cmp.w	txmax(a3),d0
	bls	@f
	bsr	_cur_crlf
@@:
	bsr	_cur_right
	rts

_ctrl_0D:
* CR
	move.w	tcurx(a3),d0
	cmp.w	txmax(a3),d0
	bls	@f
	bsr	_cur_crlf
@@:
	clr.w	tcurx(a3)
	bsr	_curx_calc
	rts

_ctrl_1A:
* SUB
	movem.l	d1-d4,-(sp)
	move.w	tx(a3),d1
	addq.w	#1,d1
	add.w	txs(a3),d1
	mulu.w	d6,d1
	move.w	ty(a3),d2
	addq.w	#1,d2
	add.w	tys(a3),d2
	mulu.w	tfsize(a3),d2

	move.w	txmax(a3),d3
	addq.w	#1,d3
	mulu.w	d6,d3
	move.w	tymax(a3),d4
	addq.w	#1,d4
	mulu.w	tfsize(a3),d4

	move.l	tvram(a3),a1	* uq`lAhX

	jsr	__tclr3		* ʃNA

	movem.l	(sp)+,d1-d4
	bsr	_cur_home
	rts

_ctrl_1E:
* RS
	bsr	_cur_home
	rts

_ctrl_1B:
* ESC
	lea	tescbuf(a3),a0
	move.b	#$1b,(a0)+		* ESCV[PXJn
	clr.b	(a0)+			* [
	clr.b	(a0)+			* V[PX擪
	rts

* J[\ȍ~s܂ŏ
_clr_from_cursor:
	move.w	tcurx(a3),d0
	cmp.w	txmax(a3),d0
	bhi	_clr_from_cursor_end

	movem.l	d1-d4,-(sp)
	move.w	tx(a3),d1
	addq.w	#1,d1
	add.w	txs(a3),d1
	add.w	tcurx(a3),d1
	mulu.w	d6,d1

	move.w	ty(a3),d2
	addq.w	#1,d2
	add.w	tys(a3),d2
	add.w	tcury(a3),d2
	mulu.w	tfsize(a3),d2

	move.w	txmax(a3),d3
	addq.w	#1,d3
	sub.w	tcurx(a3),d3
	mulu.w	d6,d3
	move.w	tfsize(a3),d4

	move.l	tvram(a3),a1	* uq`lAhX

	jsr	__tclr3		* NA

	movem.l	(sp)+,d1-d4
_clr_from_cursor_end:
	rts

* sJ[\܂ŏ
_clr_to_cursor:
	move.w	tcurx(a3),d0
	cmp.w	txmax(a3),d0
	bhi	_clr_line_of_cursor

	movem.l	d1-d4,-(sp)
	move.w	tx(a3),d1
	addq.w	#1,d1
	add.w	txs(a3),d1
	mulu.w	d6,d1

	move.w	ty(a3),d2
	addq.w	#1,d2
	add.w	tys(a3),d2
	add.w	tcury(a3),d2
	mulu.w	tfsize(a3),d2

	move.w	tcurx(a3),d3
	mulu.w	d6,d3
	move.w	tfsize(a3),d4

	move.l	tvram(a3),a1	* uq`lAhX

	jsr	__tclr3		* NA

	movem.l	(sp)+,d1-d4
	rts

* J[\s
_clr_line_of_cursor:
	movem.l	d1-d4,-(sp)
	move.w	tx(a3),d1
	addq.w	#1,d1
	add.w	txs(a3),d1
	mulu.w	d6,d1

	move.w	ty(a3),d2
	addq.w	#1,d2
	add.w	tys(a3),d2
	add.w	tcury(a3),d2
	mulu.w	tfsize(a3),d2

	move.w	txmax(a3),d3
	addq.w	#1,d3
	mulu.w	d6,d3
	move.w	tfsize(a3),d4

	move.l	tvram(a3),a1	* uq`lAhX

	jsr	__tclr3		* NA

	movem.l	(sp)+,d1-d4
	rts

* J[\s艺
_clr_from_next_line_of_cursor:
	move.w	tcury(a3),d0
	cmp.w	tymax(a3),d0
	beq	_clr_from_next_line_of_cursor_end

	movem.l	d1-d4,-(sp)
	move.w	tx(a3),d1
	addq.w	#1,d1
	add.w	txs(a3),d1
	mulu.w	d6,d1

	move.w	ty(a3),d2
	addq.w	#1,d2
	add.w	tys(a3),d2
	add.w	tcury(a3),d2
	addq.w	#1,d2
	mulu.w	tfsize(a3),d2

	move.w	txmax(a3),d3
	addq.w	#1,d3
	mulu.w	d6,d3

	move.w	tymax(a3),d4
	sub.w	tcury(a3),d4
	mulu.w	tfsize(a3),d4

	move.l	tvram(a3),a1	* uq`lAhX

	jsr	__tclr3		* NA

	movem.l	(sp)+,d1-d4
_clr_from_next_line_of_cursor_end:
	rts

* J[\s
_clr_to_prev_line_of_cursor:
	tst.w	tcury(a3)
	beq	_clr_to_prev_line_of_cursor_end

	movem.l	d1-d4,-(sp)
	move.w	tx(a3),d1
	addq.w	#1,d1
	add.w	txs(a3),d1
	mulu.w	d6,d1

	move.w	ty(a3),d2
	addq.w	#1,d2
	add.w	tys(a3),d2
	mulu.w	tfsize(a3),d2

	move.w	txmax(a3),d3
	addq.w	#1,d3
	mulu.w	d6,d3

	move.w	tcury(a3),d4
	mulu.w	tfsize(a3),d4

	move.l	tvram(a3),a1	* uq`lAhX

	jsr	__tclr3		* NA

	movem.l	(sp)+,d1-d4
_clr_to_prev_line_of_cursor_end:
	rts

* d0.w = J[\Yʒu{폜s
_delete_line:
	movem.l	d1-d5,-(sp)
	move.w	tx(a3),d1
	addq.w	#1,d1
	add.w	txs(a3),d1
	mulu.w	d6,d1

	move.w	ty(a3),d2
	addq.w	#1,d2
	add.w	tys(a3),d2
	move.w	d2,d5
	add.w	d0,d2			* J[\ʒu+폜s𑫂
	add.w	tcury(a3),d5
	mulu.w	tfsize(a3),d2
	mulu.w	tfsize(a3),d5

	move.w	txmax(a3),d3
	addq.w	#1,d3
	mulu.w	d6,d3

	move.w	tymax(a3),d4
	sub.w	tcury(a3),d4
	addq.w	#1,d4			* J[\s̕
	sub.w	tcury(a3),d0		* d0 = 폜s
	sub.w	d0,d4			* 폜
	mulu.w	tfsize(a3),d4

	move.l	tvram(a3),a1	* uq`lAhX

	move.w	d0,-(sp)
	jsr	__tycopy	* Rs[
	move.w	(sp)+,d4

	move.w	ty(a3),d2
	addq.w	#1,d2
	add.w	tys(a3),d2
	add.w	tymax(a3),d2
	sub.w	d4,d2
	addq.w	#1,d2
	mulu.w	tfsize(a3),d2
	mulu.w	tfsize(a3),d4

	jsr	__tclr3			* 폜ċ󂢂NA

	movem.l	(sp)+,d1-d5
	rts

* d0.w = J[\Yʒu{}s
_insert_line:
	movem.l	d1-d5,-(sp)
	move.w	tx(a3),d1
	addq.w	#1,d1
	add.w	txs(a3),d1
	mulu.w	d6,d1

	sub.w	tcury(a3),d0		* d0 = }s
	move.w	ty(a3),d2
	addq.w	#1,d2
	add.w	tys(a3),d2
	add.w	tymax(a3),d2
	addq.w	#1,d2
	move.w	d2,d5
	sub.w	d0,d2			* }
	mulu.w	tfsize(a3),d2
	mulu.w	tfsize(a3),d5
	subq.w	#1,d2
	subq.w	#1,d5
	bset.l	#15,d5

	move.w	txmax(a3),d3
	addq.w	#1,d3
	mulu.w	d6,d3

	move.w	tymax(a3),d4
	sub.w	tcury(a3),d4
	addq.w	#1,d4			* J[\s̕
	sub.w	d0,d4			* }
	mulu.w	tfsize(a3),d4

	move.l	tvram(a3),a1	* uq`lAhX

	move.w	d0,-(sp)
	jsr	__tycopy	* Rs[
	move.w	(sp)+,d4

	move.w	ty(a3),d2
	addq.w	#1,d2
	add.w	tys(a3),d2
	add.w	tcury(a3),d2
	mulu.w	tfsize(a3),d2
	mulu.w	tfsize(a3),d4

	jsr	__tclr3			* }NA

	movem.l	(sp)+,d1-d5
	rts

* GXP[vV[PX̃`FbN HIOCS Qlɂ܂.
_escsq_check:
	move.b	(a0)+,d0
	cmp.b	#'[',d0
	beq	_escsq_0
	cmp.b	#'=',d0
	beq	_escsq_1
	cmp.b	#'*',d0
	beq	_escsq_2
	cmp.b	#'D',d0
	beq	_escsq_3
	cmp.b	#'E',d0
	beq	_escsq_4
	cmp.b	#'M',d0
	beq	_escsq_5
	bra	_escsq_error

_escsq_check_end:
	rts

_escsq_end:
	lea	tescbuf(a3),a0
	clr.w	(a0)+			* V[PXobt@NA
	clr.b	(a0)+
	bra	_escsq_check_end

_escsq_getnum:
	clr.w	d0
	move.w	#$8000,d1		* ŏʃrbg̓tO
@@:
	move.b	(a0)+,d0
	cmp.b	#' ',d0
	beq	@b
	cmp.b	#'0',d0
	bcs	@f
	cmp.b	#'9'+1,d0
	bcc	@f
	sub.b	#'0',d0
	mulu.w	#10,d1
	add.w	d0,d1
	bra	@b
@@:
	rts

_escsq_0:
	move.b	d1,d0
	or.b	#$20,d0			* 
	sub.b	#$60,d0
	cmp.b	#$1b,d0			* At@xbgȁH
	bcs	@f
	cmp.b	#18+1,tescbuf+1(a3)
	bcc	_escsq_error		* obt@肷Ă.
	bra	_escsq_check_end	* ܂V[PXĂȂ
@@:
	cmp.b	#'>',(a0)
	beq	_escsq_00		* ESC [>
	cmp.b	#'?',(a0)
	beq	_escsq_01		* ESC [?
	bsr	_escsq_getnum

	cmp.b	#'A',d0
	beq	_escsq_A
	cmp.b	#'B',d0
	beq	_escsq_B
	cmp.b	#'C',d0
	beq	_escsq_C
	cmp.b	#'D',d0
	beq	_escsq_D

	cmp.b	#'J',d0
	beq	_escsq_J
	cmp.b	#'K',d0
	beq	_escsq_K
	cmp.b	#'M',d0
	beq	_escsq_M
	cmp.b	#'L',d0
	beq	_escsq_L

	cmp.b	#'s',d0
	beq	_escsq_s
	cmp.b	#'u',d0
	beq	_escsq_u

*	cmp.b	#'n',d0
*	beq	_escsq_n
*	cmp.b	#'P',d0
*	beq	_escsq_P
*	cmp.b	#'@',d0
*	beq	_escsq_@
*	cmp.b	#'X',d0
*	beq	_escsq_X

	cmp.b	#'m',d0
	beq	_escsq_m1

	cmp.b	#';',d0
	bne	_escsq_error
	move.w	d1,d2
	bsr	_escsq_getnum

	cmp.b	#'H',d0
	beq	_escsq_H
	cmp.b	#'f',d0
	beq	_escsq_f

	cmp.b	#'m',d0
	beq	_escsq_m2

	cmp.b	#';',d0
	bne	_escsq_error
	move.w	d1,d3
	bsr	_escsq_getnum

	cmp.b	#'m',d0
	beq	_escsq_m3
	bra	_escsq_error

_escsq_00:			* ESC [>..
	addq.l	#1,a0
	move.w	(a0)+,d0
	cmp.w	#'5l',d0
	bne	1f
	move.w	#1,cursw(a6)
*	move.l	a3,a0
*	jsr	__twincuron
	bra	2f
1:
	cmp.w	#'5h',d0
	clr.w	cursw(a6)
*	move.l	a3,a0
*	jsr	__twincuroff
2:
	bra	_escsq_end

_escsq_01:			* ESC [?..
	addq.l	#1,a0
	move.w	(a0)+,d0
	cmp.w	#'4h',d0
	bne	1f
	move.w	#1,tscmod(a3)
	bra	2f
1:
	cmp.w	#'4l',d0
	bne	2f
	clr.w	tscmod(a3)
2:
	bra	_escsq_end

_escsq_A:
	tst.w	d1
	bgt	@f
	moveq.l	#1,d1
@@:
	move.w	tcury(a3),d0
	sub.w	d1,d0
	bpl	@f
	moveq.l	#0,d0
@@:
	move.w	d0,tcury(a3)
	bsr	_cury_calc
	bra	_escsq_end

_escsq_B:
	tst.w	d1
	bgt	@f
	moveq.l	#1,d1
@@:
	move.w	tcury(a3),d0
	add.w	d1,d0
	cmp.w	tymax(a3),d0
	bls	@f
	move.w	tymax(a3),d0
@@:
	move.w	d0,tcury(a3)
	bsr	_cury_calc
	bra	_escsq_end

_escsq_C:
	tst.w	d1
	bgt	@f
	moveq.l	#1,d1
@@:
	move.w	tcurx(a3),d0
	add.w	d1,d0
	cmp.w	txmax(a3),d0
	bls	@f
	move.w	txmax(a3),d0
@@:
	move.w	d0,tcurx(a3)
	bsr	_curx_calc
	bra	_escsq_end

_escsq_D:
	tst.w	d1
	bgt	@f
	moveq.l	#1,d1
@@:
	move.w	tcurx(a3),d0
	sub.w	d1,d0
	bpl	@f
	moveq.l	#0,d0
@@:
	move.w	d0,tcurx(a3)
	bsr	_curx_calc
	bra	_escsq_end

* J[\ʒu
_escsq_J:
	tst.w	d1
	bgt	@f
	moveq.l	#0,d1
@@:
	cmp.w	#0,d1
	beq	_escsq_J0
	cmp.w	#1,d1
	beq	_escsq_J1
	cmp.w	#2,d1
	beq	_escsq_J2
	bra	_escsq_error		* ȊO͂Ƃ肠G[ɂ.

_escsq_J0:
	bsr	_clr_from_cursor
	bsr	_clr_from_next_line_of_cursor
	bra	_escsq_end

_escsq_J1:
	bsr	_clr_to_prev_line_of_cursor
	bsr	_clr_to_cursor
	bra	_escsq_end

_escsq_J2:
	bsr	_ctrl_1A
	bra	_escsq_end

_escsq_K:
	tst.w	d1
	bgt	@f
	moveq.l	#0,d1
@@:
	cmp.w	#0,d1
	beq	_escsq_K0
	cmp.w	#1,d1
	beq	_escsq_K1
	cmp.w	#2,d1
	beq	_escsq_K2
	bra	_escsq_error		* ȊO͂Ƃ肠G[ɂ.

_escsq_K0:
	bsr	_clr_from_cursor
	bra	_escsq_end

_escsq_K1:
	bsr	_clr_to_cursor
	bra	_escsq_end

_escsq_K2:
	bsr	_clr_line_of_cursor
	bra	_escsq_end

_escsq_M:
	tst.w	d1
	bgt	@f
	moveq.l	#1,d1
@@:
	move.w	tcury(a3),d0
	add.w	d1,d0
	cmp.w	tymax(a3),d0		* XN[\ȁH
	bls	@f
	bsr	_clr_line_of_cursor
	bsr	_clr_from_next_line_of_cursor
	bsr	_ctrl_0D
	bra	_escsq_end
@@:
	bsr	_delete_line
	bsr	_ctrl_0D
	bra	_escsq_end

_escsq_L:
	tst.w	d1
	bgt	@f
	moveq.l	#1,d1
@@:
	move.w	tcury(a3),d0
	add.w	d1,d0
	cmp.w	tymax(a3),d0		* XN[\ȁH
	bls	@f
	bsr	_clr_line_of_cursor
	bsr	_clr_from_next_line_of_cursor
	bsr	_ctrl_0D
	bra	_escsq_end
@@:
	bsr	_insert_line
	bsr	_ctrl_0D
	bra	_escsq_end

_escsq_s:
	tst.w	d1
	bpl	_escsq_error
	move.w	tpcol(a3),tcolsave(a3)
	move.w	tcurx(a3),tcurxsave(a3)
	move.w	tcury(a3),tcurysave(a3)
	bra	_escsq_end

_escsq_u:
	tst.w	d1
	bpl	_escsq_error
	move.w	tcolsave(a3),tpcol(a3)
	move.w	tcurxsave(a3),tcurx(a3)
	move.w	tcurysave(a3),tcury(a3)
	bsr	__tputs_color_set
	bsr	_cury_calc
	bsr	_curx_calc
	bra	_escsq_end

_escsq_H:
_escsq_f:
	tst.w	d1			* XȗH
	bgt	@f
	moveq.l	#1,d1
@@:
	tst.w	d2			* YȗH
	bgt	@f
	moveq.l	#1,d2
@@:
	subq.w	#1,d1			* sJ->J[\ʒuɕϊ
	subq.w	#1,d2

	cmp.w	txmax(a3),d1		* ől𒴂Ȃ悤ɂ
	bls	@f
	move.w	txmax(a3),d1
@@:
	cmp.w	tymax(a3),d2
	bls	@f
	move.w	tymax(a3),d2
@@:
	move.w	d1,tcurx(a3)		* J[\ʒuݒ肵āA
	move.w	d2,tcury(a3)
	bsr	_curx_calc		* AhXvZāA
	bsr	_cury_calc
	bra	_escsq_end		* V[PX.

_escsq_m3:
	move.w	d2,d0
	bsr	_escsq_m_sub
	tst.l	d0
	bmi	_escsq_error
	move.w	d3,d2
_escsq_m2:
	move.w	d2,d0
	bsr	_escsq_m_sub
	tst.l	d0
	bmi	_escsq_error
_escsq_m1:
	move.w	d1,d0
	bsr	_escsq_m_sub
	tst.l	d0
	bmi	_escsq_error
	bra	_escsq_end

_escsq_m_sub:
	tst.w	d0
	ble	_escsq_m_sub_init
	cmp.w	#1,d0
	beq	_escsq_m_sub_high_light
	cmp.w	#7,d0
	beq	_escsq_m_sub_reverse

	cmp.w	#30,d0
	bcs	_escsq_m_sub_error
	cmp.w	#37+1,d0
	bcc	@f
	sub.w	#30,d0
	move.w	d0,tpcol(a3)
	bra	_escsq_m_sub_end
@@:
	cmp.w	#40,d0
	bcs	_escsq_m_sub_error
	cmp.w	#47+1,d0
	bcc	_escsq_m_sub_error
	sub.w	#32,d0
	move.w	d0,tpcol(a3)
_escsq_m_sub_end:
	bsr	__tputs_color_set
	clr.l	d0
	rts

_escsq_m_sub_error:
	moveq.l	#-1,d0
	rts

_escsq_m_sub_init:
	move.b	#3,tpcol+1(a3)
	bra	_escsq_m_sub_end

_escsq_m_sub_high_light:
	bchg.b	#2,tpcol+1(a3)
	bra	_escsq_m_sub_end

_escsq_m_sub_reverse:
	bchg.b	#3,tpcol+1(a3)
	bra	_escsq_m_sub_end

_escsq_1:
	cmp.b	#3,tescbuf+1(a3)
	bne	_escsq_check_end	* ܂V[PXĂȂ
	clr.w	d1
	clr.w	d2
	move.b	(a0)+,d2
	move.b	(a0)+,d1
	moveq.l	#$20,d0			* sJ->J[\ʒuɕϊ
	sub.w	d0,d1
	bmi	_escsq_error
	sub.w	d0,d2
	bmi	_escsq_error

	cmp.w	txmax(a3),d1		* ől𒴂Ȃ悤ɂ
	bls	@f
	move.w	txmax(a3),d1
@@:
	cmp.w	tymax(a3),d2
	bls	@f
	move.w	tymax(a3),d2
@@:
	move.w	d1,tcurx(a3)		* J[\ʒuݒ肵āA
	move.w	d2,tcury(a3)
	bsr	_curx_calc		* AhXvZāA
	bsr	_cury_calc
	bra	_escsq_end		* V[PX.

* ESC *
_escsq_2:
	bsr	_ctrl_1A
	bra	_escsq_end

* ESC D
_escsq_3:
	bsr	_ctrl_0A
	bra	_escsq_end

* ESC E
_escsq_4:
	bsr	_ctrl_0D
	bsr	_ctrl_0A
	bra	_escsq_end

* ESC M
_escsq_5:
	move.w	tcury(a3),d0
	subq.w	#1,d0
	bmi	@f
	move.w	d0,tcury(a3)
	bsr	_cury_calc
	bra	_escsq_end
@@:
	clr.w	tcury(a3)
	bsr	_cury_calc
	bsr	_scroll_down
	bra	_escsq_end

_escsq_error:
	move.l	a4,-(sp)
	lea	tescbuf+2(a3),a4
_esqsq_error_loop:
	clr.w	d1
	move.b	(a4)+,d1
	beq	_escsq_error_end
	cmp.b	#$e0,d1
	bcc	_escsq_error_kanji
	cmp.b	#$a0,d1
	bcc	_escsq_error_ank
	cmp.b	#$80,d1
	bcc	_escsq_error_kanji
	cmp.b	#$20,d1
	bcc	_escsq_error_ank
	bra	_esqsq_error_loop

_escsq_error_kanji:
	lsl.w	#8,d1
	move.b	(a4)+,d1
	beq	_escsq_error_end
_escsq_error_ank:
	bsr	__tputs_sub
	bra	_esqsq_error_loop

_escsq_error_end:
	move.l	(sp)+,a4
	bra	_escsq_end

	.end
