* c_twincuron.s

	.include	core.mac
	.include	../twin.mac
	.include	../twin_version.mac

	.xdef	_c_twincuron
	.xdef	_twincuron

	.xdef	__twincuron
	.xdef	__twincurrev

	.xref	__get_twinwork
	.xref	blinkmode
	.xref	blinktbl
	.xref	__teor2
	.xref	coreblinkmode


*-------------------------------------------------------------------------------
* J[\I
* a0 = [N|C^

__twincuron:
	movem.l	d0-d1/a0-a1,-(sp)
	tst.b	tcursw(a0)
	bne	__twincuron_end		* \

	move.w	tno(a0),d0
	add.w	d0,d0
	lea	coreuse,a1
	move.w	(a1,d0.w),d0
	lea	coreblinkmode,a1
	tst.b	(a1,d0.w)		* _łł邩H
	bne	@f

	bsr	__twincurrev		* J[\p^[𔽓]\
	move.b	#1,tcurstat(a0)		* \
	move.b	tcurtimer(a0),tcurtimer+1(a0)	* ^C}[
	move.b	#1,tcursw(a0)		* \Jn
	bra	1f
@@:
	move.b	#5,tcurtimer+1(a0)	* ^C}[
	move.b	#1,tcursw(a0)		* \Jn

	move.w	tno(a0),d0
	move.w	d0,d1
	lsr.w	#3,d1
	and.w	#%111,d0
	lea	blinktbl,a0
	bset.b	d0,(a0,d1.w)		* _ŊJn
1:
__twincuron_end:
	movem.l	(sp)+,d0-d1/a0-a1
	rts


*-------------------------------------------------------------------------------
* J[\]
* a0 = [N|C^

__twincurrev:
	movem.l	d1-d2/a0-a1,-(sp)
	move.w	tcurx(a0),d1
	cmp.w	txmax(a0),d1
	bls	@f
	move.w	txmax(a0),d1		* J[\͈͊O
@@:
	add.w	tx(a0),d1
	addq.w	#1,d1
	add.w	txs(a0),d1
	mulu.w	tfsize(a0),d1
	lsr.w	#1,d1

	move.w	ty(a0),d2
	addq.w	#1,d2
	add.w	tys(a0),d2
	add.w	tcury(a0),d2
	mulu.w	tfsize(a0),d2

	move.l	tvram(a0),a1
	move.l	tcurpat(a0),a0
	jsr	__teor2
__twincurrev_end:
	movem.l	(sp)+,d1-d2/a0-a1
	rts


*-------------------------------------------------------------------------------
* int twincuron( win );
* TWIN *win;

	.text
_c_twincuron:
_twincuron:
	move.l	4(sp),d1

	jsr	__get_twinwork
	tst.l	d0
	bmi	_twincuron_error
	move.l	d0,a0			* a0.l = EChE|C^

	tst.w	tdraw(a0)
	beq	_twincuron_error	* ܂\ĂȂ.

	bsr	__twincuron		* J[\\

	clr.l	d0
_twincuron_end:
	rts

_twincuron_error:
	moveq.l	#-1,d0
	bra	_twincuron_end

	.end
