/* twin.h */

#ifndef	__twin_h__
#define	__twin_h__

#include	<stddef.h>

#ifdef	__LIBC__
#include	<sys/iocs.h>
#else
/* for XC library */
#include	<iocslib.h>
#define	_fntbuf	FNTBUF
#endif

/*----------------------------------------------------------------------------*/
/* [N͎QƂ݂̂ŒڏȂ悤ɂĉ(ꕔO) */

typedef struct twinwork {
	short tno;				/* EBhEio */
	short tdraw;			/* EBhE\tO */
	short ttype;			/* EBhE^Cv */
	short tscmod;			/* XN[[h */

	short tx;				/* EBhE\ʒu */
	short ty;
	short twx;				/* EBhETCY */
	short twy;
	short tcol;				/* EBhEF */
	short tfsize;			/* tHgTCY */

	short tbcol;			/* EBhEwiF */
	short ttcol;			/* ^Cg\F */

	void *tvram;			/* VRAM擪AhX */
	char *ttitle;			/* EBhE^Cg */
	void *tbufp;			/* [Nobt@(NULL = Ȃ) */

	short txs;				/* _Wʒu */
	short tys;
	short txmax;			/* ő\|P */
	short tymax;			/* ő\s|P */

	char tcursw;			/* J[\\XCb` */
	char tcurstat;			/* J[\\ */
	short tcurtimer;		/* J[\\ */
	struct _fntbuf *tcurpat;	/* J[\p^[AhX */
	short tcurx;			/* J[\ʒu */
	short tcury;

	short tpcol;			/* \F */

	short tcolsave;			/* ꎞۑobt@ */
	short tcurxsave;
	short tcurysave;

	short treserve[2];		/* \̈ */

	short tcoreno;			/* coreio */

	char tescbuf[20];		/* ESCV[PXobt@ or 2oCgR[h擪1oCg */
} TWIN;

/*----------------------------------------------------------------------------*/
/* EBhE^Cv̒` */

enum {	WIN_STD = 0,
		WIN_MINT,
		WINTYPE_MAX };

/*----------------------------------------------------------------------------*/
/* ֐錾 */

extern	int twininit( void );
extern	int twinend( int );
extern	TWIN* twinopen( short, short, short, short, short, short );
extern	int twinclose( TWIN* );
extern	int twincloseall( void );
extern	int twinresize( TWIN* , short, short, short, short, short, short );
extern	int twinconsol( TWIN*, short, short, short, short );
extern	int twinlocate( TWIN*, short, short );
extern	int twincolor( TWIN*, short );
extern	int twincuron( TWIN* );
extern	int twincuroff( TWIN* );
extern	int twindraw( TWIN*, short, char*, short );
extern	int twinredraw( TWIN*, short, char*, short );
extern	int twinclear( TWIN* );
extern	int twincls( TWIN* );
extern	int twinprint( TWIN*, char* );
extern	int twinputc( TWIN*, int );
extern	int twinputfnt( TWIN*, struct _fntbuf* );
extern	int twinworksize( TWIN* );
extern	void twinblinkon( void );
extern	void twinblinkoff( void );

extern	int tycopy( short, short, short, short, short, void* );
extern	int tclr( short, short, short, short, void* );
extern	int tclr3( short, short, short, short, void* );
extern	int trev( short, short, short, short, void* );
extern	int trev3( short, short, short, short, void* );
extern	int teor2( short, short, struct _fntbuf*, void* );
extern	int tput( short, short, struct _fntbuf*, void* );
extern	int tput3( short, short, struct _fntbuf*, void* );
extern	int tget( short, short, struct _fntbuf*, void* );
extern	struct _fntbuf **getfonttable( short );

#endif	/* __twin_h__ */
