* twinblinkon.s

	.include	doscall.mac
	.include	twin.mac
	.include	twin_version.mac

	.xdef	_twinblinkon

	.xref	__twincurrev
	.xref	_twinblinkoff
	.xref	twinwork
	.xref	blinkmode
	.xref	blinktbl
	.xref	blinktblsize
	.xref	blink_old


*-------------------------------------------------------------------------------
* void twinblinkon(void);
*
* ^C}[b̃tbNƃxN^A[`̓o^

	.text
_twinblinkon:
	tst.b	blinkmode
	bne	@f
	bsr	__blink_set
@@:
	rts

*-------------------------------------------------------------------------------
* _ŏ

	.text
__blink:
	movem.l	d0-d4/a0-a1,-(sp)
	lea	blinktbl,a1
	move.w	blinktblsize,d2
	subq.w	#1,d2
	move.w	d2,d3
1:
	tst.b	(a1)+
	bne	@f
	dbra	d2,1b
	bra	__blink_end
@@:
	move.w	d3,d0
	sub.w	d2,d0
	mulu.w	#twinworksize*8,d0
	lea	twinwork,a0
	add.l	d0,a0
	move.b	-1(a1),d4
	moveq.l	#8-1,d1
2:
	lsr.b	#1,d4
	bcc	@f
	tst.b	tcursw(a0)
	beq	@f

	subq.b	#1,tcurtimer+1(a0)
	bne	@f
	move.b	tcurtimer(a0),tcurtimer+1(a0)	* ^C}[
	bsr	__twincurrev			* J[\p^[𔽓]\
	eor.b	#1,tcurstat(a0)
@@:
	add.w	#twinworksize,a0
	dbra	d1,2b
	dbra	d2,1b
__blink_end:
	movem.l	(sp)+,d0-d4/a0-a1
	move.l	blink_old,-(sp)
	rts

*-------------------------------------------------------------------------------
* [`̓o^

	.text
ctrlc_old:
	.dc.l	0
abort_old:
	.dc.l	0

	.text
__blink_set:
	move.l	d0,-(sp)
	clr.l	blink_old

	pea	__blink_ctrlc(pc)
	move.w	#$fff1,-(sp)
	DOS	__INTVCS
	move.l	d0,ctrlc_old
	addq.l	#6,sp

	pea	__blink_abort(pc)
	move.w	#$fff2,-(sp)
	DOS	__INTVCS
	move.l	d0,abort_old
	addq.l	#6,sp

	pea	__blink(pc)
	move.w	#$0045,-(sp)
	DOS	__INTVCS
	move.l	d0,blink_old
	move.b	#1,blinkmode
	addq.l	#6,sp

	move.l	(sp)+,d0
	rts

__blink_ctrlc:
	jsr	_twinblinkoff
	move.l	ctrlc_old,-(sp)
	rts

__blink_abort:
	jsr	_twinblinkoff
	move.l	abort_old,-(sp)
	rts

	.end
