* twininit.s

	.include	doscall.mac
	.include	twin.mac
	.include	twin_version.mac

	.xdef	_twininit
	.xdef	twincore_no
	.xdef	twincore_flag


*-------------------------------------------------------------------------------
* int twininit( void );

	.bss
	.quad
twincore_no:
	.ds.w	1

	.data
twincore_flag:
	.dc.b	0

	.text
_twininit:
	tas.b	twincore_flag
	bne	_twininit_error
	bsr	__exit_hook
	clr.w	twincore_no
	clr.l	d0
_twininit_end:
	rts

_twininit_error:
	moveq.l	#-1,d0
	bra	_twininit_end

*-------------------------------------------------------------------------------
* [`̓o^

	.text
ctrlc_old:
	.dc.l	0
abort_old:
	.dc.l	0

	.text
__exit_hook:
	pea	__exit_ctrlc(pc)
	move.w	#$fff1,-(sp)
	DOS	__INTVCS
	move.l	d0,ctrlc_old
	addq.l	#6,sp

	pea	__exit_abort(pc)
	move.w	#$fff2,-(sp)
	DOS	__INTVCS
	move.l	d0,abort_old
	addq.l	#6,sp
	rts

__exit_ctrlc:
	move.w	twincore_no,-(sp)
	clr.w	-(sp)
	jsr	_twinend
	addq.l	#4,sp
	move.l	ctrlc_old,-(sp)
	rts

__exit_abort:
	move.w	twincore_no,-(sp)
	clr.w	-(sp)
	jsr	_twinend
	addq.l	#4,sp
	move.l	abort_old,-(sp)
	rts

	.end
