* twinopen.s

	.include	twin.mac
	.include	twin_version.mac

	.xdef	_twinopen
	.xdef	__twin_check
	.xdef	__get_twinno
	.xdef	__get_twinwork
	.xdef	__get_font_table
	.xdef	twinno
	.xdef	twinwork
	.xdef	blinkmode
	.xdef	blinktbl
	.xdef	blinktblsize

	.xref	twin_font
	.xref	twin_font12
	.xref	twin_font24


*-------------------------------------------------------------------------------
* TWIN *twinopen( x, y, wx, wy, col, fsize );
* short x, y;	/* EBhE̕\W */
* short wx, wy;	/* EBhETCY */
* short col;	/* EBhEJ[ */
* short fsize;	/* tHgTCY */
*
* [NGAmۂẴAhXԂ NULL(0) ȂG[
* EBhEɕ\镶J[ 3()ɂȂ.

	.bss
twinwork:
	.ds.b	twinworksize*TWINMAX	* twinopenԂ[N

	.data
blinktblsize:
	.dc.w	TWINMAX+7/8
blinkmode:
	.dc.b	0
blinktbl:
	.dcb.b	(TWINMAX+7/8),0
twinno:
	.dcb.b	TWINMAX,0
	.dc.b	1			* Xgbp[

	.offset	-(2+4)
link_start:
win_no:		.ds.w	1
win_work:	.ds.l	1
	.text

	.text
_twinopen:
	link.w	a6,#link_start
	movem.l	d3-d6,-(sp)
	movem.l	8(a6),d1-d6

	jsr	__twin_check
	tst.l	d0
	bmi	_twinopen_error		* p[^s

	lea	twinno,a0
@@:
	tas.b	(a0)+
	bmi	@b			* gp
	bne	_twinopen_error		* [NȂ̂ŃI[vłȂ

	subq.l	#1,a0
	sub.l	#twinno,a0
	move.l	a0,d0
	move.w	d0,win_no(a6)		* EBhEio

	mulu.w	#twinworksize,d0
	lea	twinwork,a0
	add.l	d0,a0
	move.l	a0,win_work(a6)		* EBhE[N擪

	move.w	#twinworksize,d0	* ܂[N
	subq.w	#1,d0
@@:
	clr.b	(a0)+
	dbra	d0,@b
	move.l	win_work(a6),a0

	move.w	win_no(a6),tno(a0)
	clr.w	tdraw(a0)
	clr.w	ttype(a0)
	clr.w	tscmod(a0)
	move.w	d1,tx(a0)
	move.w	d2,ty(a0)
	move.w	d3,twx(a0)
	move.w	d4,twy(a0)
	move.w	d5,tcol(a0)
	move.w	d6,tfsize(a0)
	move.l	#$00e00000,tvram(a0)
	clr.l	ttitle(a0)
	clr.w	ttcol(a0)
	clr.l	tbufp(a0)

	clr.w	txs(a0)
	clr.w	tys(a0)
	subq.w	#1,d3
	move.w	d3,txmax(a0)
	subq.w	#1,d4
	move.w	d4,tymax(a0)

	clr.b	tcursw(a0)
	clr.b	tcurstat(a0)
	move.w	#$3200,tcurtimer(a0)
	jsr	__get_font_table
	move.l	d0,a1
	move.w	#($86a1-$8640),d0
	add.w	d0,d0
	add.w	d0,d0
	move.l	(a1,d0.w),a1
	move.l	a1,tcurpat(a0)
	clr.w	tcurx(a0)
	clr.w	tcury(a0)

	move.w	#3,tpcol(a0)

	move.w	tpcol(a0),tcolsave(a0)
	move.w	tcurx(a0),tcurxsave(a0)
	move.w	tcury(a0),tcurysave(a0)

	clr.b	tescbuf(a0)

	move.l	a0,d0
_twinopen_end:
	movem.l	(sp)+,d3-d6
	unlk	a6
	rts

_twinopen_error:
	moveq.l	#0,d0			* NULL|C^
	bra	_twinopen_end

*-------------------------------------------------------------------------------
* p[^̃`FbN
*
* d1-d6: x, y, wx, wy, col, fsize

	.text
__twin_check:
	btst.l	#0,d6
	bne	__twin_check_error	* tHgTCY͋Ȃ.
	cmp.w	#12,d6
	beq	@f
	cmp.w	#16,d6
	beq	@f
	cmp.w	#24,d6
	beq	@f
	bra	__twin_check_error
@@:
	ext.l	d6

	moveq.l	#0,d0
	move.w	#1024,d0		* 1024 = eLXg̉TCY
	lsr.w	#1,d6
	add.w	d6,d0
	subq.w	#1,d0
	divu.w	d6,d0
	add.w	d6,d6

	tst.w	d1			* 0 <= x < (1024/(fsize/2)) ?
	bmi	__twin_check_error
	cmp.w	d0,d1
	bcc	__twin_check_error
	tst.w	d3			* 0 <= wx < (1024/(fsize/2))-2 ?
	bmi	__twin_check_error
	addq.w	#2,d3
	bcs	__twin_check_error
	cmp.w	d0,d3
	bcc	__twin_check_error
	subq.w	#2,d3

	moveq.l	#0,d0
	move.w	#1024,d0
	add.w	d6,d0
	subq.w	#1,d0
	divu.w	d6,d0

	tst.w	d2
	bmi	__twin_check_error
	cmp.w	d0,d2
	bcc	__twin_check_error
	tst.w	d4
	bmi	__twin_check_error
	addq.w	#2,d4
	bcs	__twin_check_error
	cmp.w	d0,d4
	bcc	__twin_check_error
	subq.w	#2,d4

	tst.w	d5			* 0 <= col <= 15 ?
	bmi	__twin_check_error
	cmp.w	#16,d5
	bcc	__twin_check_error

	moveq.l	#0,d0
__twin_check_end:
	rts

__twin_check_error:
	moveq.l	#-1,d0
	bra	__twin_check_end

*-------------------------------------------------------------------------------
* entry:
*       d1.l = TWIN|C^
* return:
*       d0.l <  0 G[
*            >= 0 [Nio

	.text
__get_twinno:
	movem.l	d1/a0,-(sp)
	move.l	d1,d0
	beq	__get_twinno_error
	lea	twinwork,a0
	sub.l	a0,d1
	bmi	__get_twinno_error
	cmp.l	#twinworksize*(TWINMAX-1),d1
	bhi	__get_twinno_error
	divu.w	#twinworksize,d1
	move.l	d0,a0
	moveq.l	#0,d0
	move.w	tno(a0),d0
	cmp.w	d0,d1
	bne	__get_twinno_error
__get_twinno_end:
	movem.l	(sp)+,d1/a0
	rts

__get_twinno_error:
	moveq.l	#-1,d0
	bra	__get_twinno_end

*-------------------------------------------------------------------------------
* entry:
*       d1.l = TWIN|C^
* return:
*       d0.l <  0 G[
*            >= 0 [N|C^

	.text
__get_twinwork:
	move.l	a0,-(sp)
	move.l	d1,a0
	move.w	tno(a0),d0
	cmp.w	#TWINMAX-1,d0
	bcc	__get_twinwork_error
	lea	twinno,a0
	tst.b	(a0,d0.w)
	beq	__get_twinwork_error	* gp
	move.l	d1,d0			* d0.l = EChE|C^
__get_twinwork_end:
	move.l	(sp)+,a0
	rts

__get_twinwork_error:
	moveq.l	#-1,d0
	bra	__get_twinwork_end

*-------------------------------------------------------------------------------
* tHge[u߂
*
* entry:
*       a0.l = TWIN |C^
* return:
*       d0.l <  0 G[
*       d0.l >  0 tHge[u擪

	.text
__get_font_table:
	move.l	#twin_font12,d0
	cmp.w	#12,tfsize(a0)
	beq	@f
	move.l	#twin_font,d0
	cmp.w	#16,tfsize(a0)
	beq	@f
	move.l	#twin_font24,d0
	cmp.w	#24,tfsize(a0)
	beq	@f
	moveq.l	#-1,d0
@@:
	rts

	.end
