* twinredraw.s

	.include	twin.mac
	.include	twin_version.mac

	.xdef	_twinredraw

	.xref	__twincuron
	.xref	__twincuroff
	.xref	__get_twinwork
	.xref	__tputs
	.xref	twinno


*-------------------------------------------------------------------------------
* int twinredraw( win, type, str, col );
* TWIN *win;
* short type;	/* EBhE^Cv */
* char *str;	/* ^Cg */
* short col;	/* ^CgJ[ */
*
* EBhE̘g̍ĕ\s(̃NAAۑ𔺂Ȃ)

	.data
_twinredraw_null_str:
	.dc.b	0

	.offset	-(350+2+2)
link_start:
titlebuf:	.ds.b	350
winchar:	.ds.w	1
cursw:		.ds.w	1
	.text

	.text
_twinredraw:
	link	a6,#link_start		* X^bNɊm
	movem.l	d3-d4/a3-a5,-(sp)
	movem.l	8(a6),d1-d4

	jsr	__get_twinwork
	tst.l	d0
	bmi	_twinredraw_error
	move.l	d0,a0			* a0.l = TWIN|C^

	tst.w	tdraw(a0)
	beq	_twinredraw_error	* ܂\ĂȂ.

	tst.w	d2
	bmi	_twinredraw_error
	cmp.w	#WINTYPE_MAX,d2
	bcc	_twinredraw_error

	tst.l	d3
	bne	@f
*	move.l	#_twinredraw_null_str,d3
	move.l	ttitle(a0),d3
@@:
	move.l	d3,a2			* ^Cgf[^ւ̃|C^

	tst.w	d4
	bmi	_twinredraw_error
	cmp.w	#16,d4
	bcc	_twinredraw_error

	clr.w	d0
	move.b	tcursw(a0),d0
	move.w	d0,cursw(a6)

	jsr	__twincuroff

	lsl.w	#3,d2
	lea	titlebuf(a6),a1
	move.w	#$8644,(a1)
	add.w	d2,(a1)+
	clr.l	d0
	move.w	twx(a0),d0
	subq.w	#1,d0
	bmi	1f

	cmp.b	#'\',(a2)
	bne	3f

	move.l	a2,a3
@@:	tst.b	(a3)+
	bne	@b
	sub.l	a2,a3
	subq.l	#1+2,a3

	cmp.b	#'C',1(a2)
	beq	_twinredraw_center
	cmp.b	#'R',1(a2)
	beq	_twinredraw_right
	cmp.b	#'L',1(a2)
	beq	_twinredraw_left
	bra	3f

_twinredraw_center:
	cmp.l	d0,a3
	bcc	_twinredraw_left

	addq.l	#2,a2
	move.l	d0,d1
	sub.l	a3,d1
	subq.l	#1,d1
	clr.w	d0
	lsr.w	#1,d1
	addx.w	d1,d0
@@:
	move.b	#$86,(a1)+
	move.b	#$40,(a1)
	add.b	d2,(a1)+
	dbra	d1,@b
@@:
	move.b	(a2)+,d1
	beq	@f
	move.b	d1,(a1)+
	bra	@b
@@:
	move.b	#$86,(a1)+
	move.b	#$40,(a1)
	add.b	d2,(a1)+
	dbra	d0,@b
	bra	1f

_twinredraw_right:
	cmp.l	d0,a3
	bcc	_twinredraw_left

	addq.l	#2,a2
	move.l	d0,d1
	sub.l	a3,d1
@@:
	move.b	#$86,(a1)+
	move.b	#$40,(a1)
	add.b	d2,(a1)+
	dbra	d1,@b
@@:
	move.b	(a2)+,d1
	beq	1f
	move.b	d1,(a1)+
	bra	@b

_twinredraw_left:
	addq.l	#2,a2
3:
	move.b	(a2)+,d1
	beq	2f
	move.b	d1,(a1)+
	dbra	d0,3b
2:
	tst.w	d0
	bmi	1f
@@:
	move.b	#$86,(a1)+
	move.b	#$40,(a1)
	add.b	d2,(a1)+
	dbra	d0,@b
1:
	move.b	#$86,(a1)+
	move.b	#$45,(a1)
	add.b	d2,(a1)+
	clr.b	(a1)+

	lea	titlebuf(a6),a2
	move.l	sp,a5
	sub.l	a1,a2
	move.l	a2,d0
	subq.l	#1,d0
	and.l	#$ffff_fffe,d0
	lea	(sp,d0.l),sp		* X^bNɊm
	lea	(sp),a4			* a4.l = 
	lea	(sp),a2

	lea	titlebuf(a6),a1
@@:
	move.b	(a1)+,(a2)+
	bne	@b

	lea	titlebuf(a6),a1
	move.w	#$8642,(a1)
	add.w	d2,(a1)+
	move.w	twx(a0),d0
	subq.w	#1,d0
	bmi	@@f
	moveq.l	#$0c,d1
@@:
	move.b	d1,(a1)+
	dbra	d0,@b
@@:
	move.b	#$86,(a1)+
	move.b	#$43,(a1)
	add.b	d2,(a1)+
	clr.b	(a1)+

	lea	titlebuf(a6),a2
	sub.l	a1,a2
	move.l	a2,d0
	subq.l	#1,d0
	and.l	#$ffff_fffe,d0
	lea	(sp,d0.l),sp		* X^bNɊm
	lea	(sp),a3			* a3.l = 
	lea	(sp),a2

	lea	titlebuf(a6),a1
@@:
	move.b	(a1)+,(a2)+
	bne	@b

	lea	titlebuf(a6),a1
	move.w	#$8647,(a1)
	add.w	d2,(a1)+
	move.w	twx(a0),d0
	subq.w	#1,d0
	bmi	@@f
@@:
	move.w	#$8641,(a1)
	add.w	d2,(a1)+
	dbra	d0,@b
@@:
	move.w	#$8646,(a1)
	add.w	d2,(a1)+
	clr.w	(a1)+

	lea	titlebuf(a6),a1		* a1.l = 

	move.w	tpcol(a0),-(sp)		* ۑ
	move.w	tx(a0),-(sp)
	move.w	ty(a0),-(sp)
	move.w	txs(a0),-(sp)
	move.w	tys(a0),-(sp)
	move.w	txmax(a0),-(sp)
	move.w	tymax(a0),-(sp)
	move.w	tcurx(a0),-(sp)
	move.w	tcury(a0),-(sp)

	subq.w	#1,tx(a0)
	subq.w	#1,ty(a0)
	clr.w	txs(a0)
	clr.w	tys(a0)
	move.w	twx(a0),txmax(a0)
	move.w	twy(a0),tymax(a0)
	addq.w	#2,txmax(a0)
	addq.w	#2,tymax(a0)
	clr.w	tcurx(a0)
	clr.w	tcury(a0)

	move.w	d4,tpcol(a0)
	exg.l	a4,a1
	jsr	__tputs
	move.w	tcol(a0),tpcol(a0)

	move.w	twy(a0),d4
	subq.w	#1,d4
	bmi	@@f
@@:
	clr.w	tcurx(a0)
	addq.w	#1,tcury(a0)
	move.l	a3,a1
	jsr	__tputs
	dbra	d4,@b
@@:
	clr.w	tcurx(a0)
	addq.w	#1,tcury(a0)
	move.l	a4,a1
	jsr	__tputs

	move.w	(sp)+,tcury(a0)		* A
	move.w	(sp)+,tcurx(a0)
	move.w	(sp)+,tymax(a0)
	move.w	(sp)+,txmax(a0)
	move.w	(sp)+,tys(a0)
	move.w	(sp)+,txs(a0)
	move.w	(sp)+,ty(a0)
	move.w	(sp)+,tx(a0)
	move.w	(sp)+,tpcol(a0)

	move.l	a5,sp			* [NGAԊ

	lea	twinno,a1
	move.w	tno(a0),d0
	bset.b	#0,(a1,d0.w)		* \
	move.w	#1,tdraw(a0)

	tst.w	cursw(a6)
	beq	@f
	jsr	__twincuron
@@:
	clr.l	d0
_twinredraw_end:
	movem.l	(sp)+,d3-d4/a3-a5
	unlk	a6
	rts

_twinredraw_error:
	moveq.l	#-1,d0
	bra	_twinredraw_end

	.end
