* twinresize.s

	.include	twin.mac
	.include	twin_version.mac

	.xdef	_twinresize

	.xref	__twin_check
	.xref	__get_twinwork
	.xref	__twincuron
	.xref	__twincuroff


*-------------------------------------------------------------------------------
* int twinresize( win, x, y, wx, wy, col, fsize );
* TWIN *win;
* short x, y, wx, wy, col, fsize;
*
* EBhETCYĐݒ肷.

	.text
_twinresize:
	link	a6,#-2
	movem.l	d3-d6,-(sp)
	movem.l	8(a6),d1

	jsr	__get_twinwork
	tst.l	d0
	bmi	_twinresize_error
	move.l	d0,a0			* a0.l = EChE|C^

	movem.l	12(a6),d1-d6
	jsr	__twin_check
	tst.l	d0
	bmi	_twinresize_error

	tst.w	tdraw(a0)
	bne	_twinresize_error

	clr.w	d0
	move.b	tcursw(a0),d0
	move.w	d0,-2(a6)

	jsr	__twincuroff

	move.w	d1,tx(a0)
	move.w	d2,ty(a0)
	move.w	d3,twx(a0)
	move.w	d4,twy(a0)
	move.w	d5,tcol(a0)
	move.w	d6,tfsize(a0)

	clr.w	txs(a0)
	clr.w	tys(a0)
	subq.w	#1,d3
	move.w	d3,txmax(a0)
	subq.w	#1,d4
	move.w	d4,tymax(a0)

	clr.b	tcursw(a0)
	clr.b	tcurstat(a0)
	clr.w	tcurx(a0)
	clr.w	tcury(a0)

	move.w	#3,tpcol(a0)

	move.w	tpcol(a0),tcolsave(a0)
	move.w	tcurx(a0),tcurxsave(a0)
	move.w	tcury(a0),tcurysave(a0)

	tst.w	-2(a6)
	beq	@f
	jsr	__twincuron
@@:
	clr.l	d0
_twinresize_end:
	movem.l	(sp)+,d3-d6
	unlk	a6
	rts

_twinresize_error:
	moveq.l	#-1,d0
	bra	_twinresize_end

	.end
