* _trev3.s

	.include	doscall.mac
	.include	iocscall.mac
	.include	twin.mac

	.xdef	__trev3


	.offset	-(4+2)
link_start:
s_stat:		.ds.l	1
crtc_r21:	.ds.w	1
	.text


*-------------------------------------------------------------------------------
* __trev3
*
* entry:
*       d1.w = XW(0`1023)
*       d2.w = YW
*       d3.w = X size
*       d4.w = Y size > 0
*       a1.l = eLXgAhX

	.text
__trev3:
	link	a6,#link_start
	movem.l	d1-d7/a0-a3/a5,-(sp)
	move.l	a1,a5

	sub.l	a1,a1
	IOCS	__B_SUPER
	move.l	d0,s_stat(a6)
	move.w	$e8002a,crtc_r21(a6)
	and.w	#$fcff,$e8002a		* VOANZXrbg}XNIt

	move.w	#$0080,a1	* a1 = 
	and.l	#$0000ffff,d2
	lsl.l	#7,d2
	add.l	d2,a5		* a5 = YW
	move.l	a5,a3
	add.l	#$20000,a3	* a3 = v[P
	move.w	d1,d5		* d5 = XW
	move.w	d3,d6		* d6 = X size
	move.w	d4,d7		* d7 = Y size

	lsr.w	#3,d1
	and.w	#%1111,d5
	add.w	d5,d5
	jsr	__trev3_tbl(pc,d5.w)
	moveq.l	#0,d1
__trev3_end:
	move.w	crtc_r21(a6),$e8002a
	move.l	s_stat(a6),d0
	bmi	@f
	move.l	d0,a1
	IOCS	__B_SUPER
@@:
	move.l	d1,d0
	movem.l	(sp)+,d1-d7/a0-a3/a5
	unlk	a6
	rts

__trev3_tbl:
	bra.s	__trev380_e
	bra.s	__trev381_e
	bra.s	__trev382_e
	bra.s	__trev383_e
	bra.s	__trev384_e
	bra.s	__trev385_e
	bra.s	__trev386_e
	bra.s	__trev387_e
	bra.s	__trev380_o
	bra.s	__trev381_o
	bra.s	__trev382_o
	bra.s	__trev383_o
	bra.s	__trev384_o
	bra.s	__trev385_o
	bra.s	__trev386_o
	bra.s	__trev387_o

__trev380_e:
	moveq.l	#%1111_1111,d2
	subq.w	#8,d6
	bra	__trev380_e1
__trev381_e:
	moveq.l	#%0111_1111,d2
	subq.w	#7,d6
	bra	__trev387_e1
__trev382_e:
	moveq.l	#%0011_1111,d2
	subq.w	#6,d6
	bra	__trev387_e1
__trev383_e:
	moveq.l	#%0001_1111,d2
	subq.w	#5,d6
	bra	__trev387_e1
__trev384_e:
	moveq.l	#%0000_1111,d2
	subq.w	#4,d6
	bra	__trev387_e1
__trev385_e:
	moveq.l	#%0000_0111,d2
	subq.w	#3,d6
	bra	__trev387_e1
__trev386_e:
	moveq.l	#%0000_0011,d2
	subq.w	#2,d6
	bra	__trev387_e1
__trev387_e:
	moveq.l	#%0000_0001,d2
	subq.w	#1,d6
	bra	__trev387_e1

__trev380_o:
	moveq.l	#%1111_1111,d2
	subq.w	#8,d6
	bra	__trev380_o1
__trev381_o:
	moveq.l	#%0111_1111,d2
	subq.w	#7,d6
	bra	@f
__trev382_o:
	moveq.l	#%0011_1111,d2
	subq.w	#6,d6
	bra	@f
__trev383_o:
	moveq.l	#%0001_1111,d2
	subq.w	#5,d6
	bra	@f
__trev384_o:
	moveq.l	#%0000_1111,d2
	subq.w	#4,d6
	bra	@f
__trev385_o:
	moveq.l	#%0000_0111,d2
	subq.w	#3,d6
	bra	@f
__trev386_o:
	moveq.l	#%0000_0011,d2
	subq.w	#2,d6
	bra	@f
__trev387_o:
	moveq.l	#%0000_0001,d2
	subq.w	#1,d6
@@:
	add.w	d1,a5
	add.w	d1,a3

	move.w	d6,d0
	ble	__trev3_s

	and.w	#%111,d0
	beq	@f
	subq.w	#1,d0
	moveq.l	#$80,d1
	asr.b	d0,d1
@@:
	moveq.l	#32,d3
	moveq.l	#$ff,d5
	subq.w	#1,d7
__trev387_o_loop:
	move.l	a5,a0
	move.l	a3,a2
	move.w	d6,d4

	eor.b	d2,(a5)+		* [NA
	eor.b	d2,(a3)+		* [NA
@@:
	sub.w	d3,d4
	bmi	@f

	eor.l	d5,(a5)+
	eor.l	d5,(a3)+
	bra	@b
@@:
	add.w	d3,d4
	beq	__trev387_o_loop_next
@@:
	subq.w	#8,d4
	bmi	@f

	eor.b	d5,(a5)+
	eor.b	d5,(a3)+
	bra	@b
@@:
	cmp.w	#-8,d4
	beq	__trev387_o_loop_next

	eor.b	d1,(a5)			* E[NA
	eor.b	d1,(a3)			* E[NA

__trev387_o_loop_next:
	move.l	a0,a5
	move.l	a2,a3
	add.w	a1,a5
	add.w	a1,a3
	dbra	d7,__trev387_o_loop
	rts

__trev387_e1:
	add.w	d1,a5
	add.w	d1,a3

	move.w	d6,d0
	ble	__trev3_s

	and.w	#%111,d0
	beq	@f
	subq.w	#1,d0
	moveq.l	#$80,d1
	asr.b	d0,d1
@@:
	moveq.l	#32,d3
	moveq.l	#$ff,d5
	subq.w	#1,d7
__trev387_e_loop:
	move.l	a5,a0
	move.l	a3,a2
	move.w	d6,d4

	eor.b	d2,(a5)+		* [NA
	eor.b	d2,(a3)+		* [NA

	subq.w	#8,d4
	bmi	1f

	eor.b	d5,(a5)+
	eor.b	d5,(a3)+
@@:
	sub.w	d3,d4
	bmi	@f

	eor.l	d5,(a5)+
	eor.l	d5,(a3)+
	bra	@b
@@:
	add.w	d3,d4
	beq	__trev387_e_loop_next
@@:
	subq.w	#8,d4
	bmi	@f

	eor.b	d5,(a5)+
	eor.b	d5,(a3)+
	bra	@b
@@:
	cmp.w	#-8,d4
	beq	__trev387_e_loop_next
1:
	eor.b	d1,(a5)			* E[NA
	eor.b	d1,(a3)			* E[NA

__trev387_e_loop_next:
	move.l	a0,a5
	move.l	a2,a3
	add.w	a1,a5
	add.w	a1,a3
	dbra	d7,__trev387_e_loop
	rts

__trev3_s:
	neg.w	d0
	beq	1f
	moveq.l	#$ff,d1
	lsl.b	d0,d1
	not.b	d1
	eor.b	d1,d2
1:
	subq.w	#1,d7
__trev3_s_loop:
	eor.b	d2,(a5)
	eor.b	d2,(a3)

	add.w	a1,a5
	add.w	a1,a3
	dbra	d7,__trev3_s_loop
	rts

__trev380_e1:
	add.w	d1,a5
	add.w	d1,a3

	move.w	d6,d0
	ble	__trev3_s
	addq.w	#8,d6

	and.w	#%111,d0
	beq	@f
	subq.w	#1,d0
	moveq.l	#$80,d1
	asr.b	d0,d1
@@:
	moveq.l	#32,d2
	moveq.l	#$ff,d5
	subq.w	#1,d7
__trev380_e_loop:
	move.l	a5,a0
	move.l	a3,a2
	move.w	d6,d4
@@:
	sub.w	d2,d4
	bmi	@f

	eor.l	d5,(a5)+
	eor.l	d5,(a3)+
	bra	@b
@@:
	add.w	d2,d4
	beq	__trev380_e_loop_next
@@:
	subq.w	#8,d4
	bmi	@f

	eor.b	d5,(a5)+
	eor.b	d5,(a3)+
	bra	@b
@@:
	cmp.w	#-8,d4
	beq	__trev380_e_loop_next

	eor.b	d1,(a5)			* E[NA
	eor.b	d1,(a3)			* E[NA
__trev380_e_loop_next:
	move.l	a0,a5
	move.l	a2,a3
	add.w	a1,a5
	add.w	a1,a3
	dbra	d7,__trev380_e_loop
	rts

__trev380_o1:
	add.w	d1,a5
	add.w	d1,a3

	move.w	d6,d0
	ble	__trev3_s

	and.w	#%111,d0
	beq	@f
	subq.w	#1,d0
	moveq.l	#$80,d1
	asr.b	d0,d1
@@:
	moveq.l	#32,d2
	moveq.l	#$ff,d5
	subq.w	#1,d7
__trev380_o_loop:
	move.l	a5,a0
	move.l	a3,a2
	move.w	d6,d4

	eor.b	d5,(a5)+
	eor.b	d5,(a3)+
@@:
	sub.w	d2,d4
	bmi	@f

	eor.l	d5,(a5)+
	eor.l	d5,(a3)+
	bra	@b
@@:
	add.w	d2,d4
	beq	__trev380_o_loop_next
@@:
	subq.w	#8,d4
	bmi	@f

	eor.b	d5,(a5)+
	eor.b	d5,(a3)+
	bra	@b
@@:
	cmp.w	#-8,d4
	beq	__trev380_o_loop_next

	eor.b	d1,(a5)			* E[NA
	eor.b	d1,(a3)			* E[NA

__trev380_o_loop_next:
	move.l	a0,a5
	move.l	a2,a3
	add.w	a1,a5
	add.w	a1,a3
	dbra	d7,__trev380_o_loop
	rts


	.end
