* _tycopy.s

	.include	doscall.mac
	.include	iocscall.mac
	.include	twin.mac

	.xdef	__tycopy


	.offset	-(4+2)
link_start:
s_stat:		.ds.l	1
crtc_r21:	.ds.w	1
	.text


*-------------------------------------------------------------------------------
* __tycopy
*
* entry:
*       d1.w = XW(0`1023)
*       d2.w = YW
*       d3.w = X size
*       d4.w = Y size
*       d5.w = Rs[YW + Rs[(bit15 = 0:ォ牺, 1:)
*       a1.l = eLXgAhX
*
* wv[ȍ~񖇂𓯎ɃRs[.


	.text
__tycopy:
	link	a6,#link_start
	movem.l	d1-d7/a0-a5,-(sp)
	move.l	a1,a5

	sub.l	a1,a1
	IOCS	__B_SUPER
	move.l	d0,s_stat(a6)
	move.w	$e8002a,crtc_r21(a6)
	and.w	#$fcff,$e8002a		* VOANZXrbg}XNIt

	move.w	#$0080,d0
	btst.l	#15,d5
	beq	@f
	moveq.l	#$80,d0
@@:
	move.w	d0,a1			* a1 = Y

	and.l	#$0000ffff,d2
	and.l	#$00007fff,d5
	lsl.l	#7,d2
	lsl.l	#7,d5
	move.l	a5,a4
	add.l	d2,a5		* a5 = ]YW
	add.l	d5,a4		* a4 = ]YW
	move.l	a5,a3
	move.l	a4,a2
	move.l	#$20000,d0
	add.l	d0,a3		* a3 = ]
	add.l	d0,a2		* a2 = ]
	move.w	d1,d5		* d5 = XW
	move.w	d3,d6		* d6 = X size
	move.w	d4,d7		* d7 = Y size

	lsr.w	#3,d1
	and.w	#%1111,d5
	add.w	d5,d5
	jsr	__tycopy_tbl(pc,d5.w)
	moveq.l	#0,d1
__tycopy_end:
	move.w	crtc_r21(a6),$e8002a
	move.l	s_stat(a6),d0
	bmi	@f
	move.l	d0,a1
	IOCS	__B_SUPER
@@:
	move.l	d1,d0
	movem.l	(sp)+,d1-d7/a0-a5
	unlk	a6
	rts

__tycopy_tbl:
	bra.s	__tycopy80_e
	bra.s	__tycopy81_e
	bra.s	__tycopy82_e
	bra.s	__tycopy83_e
	bra.s	__tycopy84_e
	bra.s	__tycopy85_e
	bra.s	__tycopy86_e
	bra.s	__tycopy87_e
	bra.s	__tycopy80_o
	bra.s	__tycopy81_o
	bra.s	__tycopy82_o
	bra.s	__tycopy83_o
	bra.s	__tycopy84_o
	bra.s	__tycopy85_o
	bra.s	__tycopy86_o
	bra.s	__tycopy87_o

__tycopy80_e:
	moveq.l	#%1111_1111,d2
	subq.w	#8,d6
	bra	__tycopy80_e1
__tycopy81_e:
	moveq.l	#%0111_1111,d2
	subq.w	#7,d6
	bra	__tycopy87_e1
__tycopy82_e:
	moveq.l	#%0011_1111,d2
	subq.w	#6,d6
	bra	__tycopy87_e1
__tycopy83_e:
	moveq.l	#%0001_1111,d2
	subq.w	#5,d6
	bra	__tycopy87_e1
__tycopy84_e:
	moveq.l	#%0000_1111,d2
	subq.w	#4,d6
	bra	__tycopy87_e1
__tycopy85_e:
	moveq.l	#%0000_0111,d2
	subq.w	#3,d6
	bra	__tycopy87_e1
__tycopy86_e:
	moveq.l	#%0000_0011,d2
	subq.w	#2,d6
	bra	__tycopy87_e1
__tycopy87_e:
	moveq.l	#%0000_0001,d2
	subq.w	#1,d6
	bra	__tycopy87_e1

__tycopy80_o:
	moveq.l	#%1111_1111,d2
	subq.w	#8,d6
	bra	__tycopy80_o1
__tycopy81_o:
	moveq.l	#%0111_1111,d2
	subq.w	#7,d6
	bra	@f
__tycopy82_o:
	moveq.l	#%0011_1111,d2
	subq.w	#6,d6
	bra	@f
__tycopy83_o:
	moveq.l	#%0001_1111,d2
	subq.w	#5,d6
	bra	@f
__tycopy84_o:
	moveq.l	#%0000_1111,d2
	subq.w	#4,d6
	bra	@f
__tycopy85_o:
	moveq.l	#%0000_0111,d2
	subq.w	#3,d6
	bra	@f
__tycopy86_o:
	moveq.l	#%0000_0011,d2
	subq.w	#2,d6
	bra	@f
__tycopy87_o:
	moveq.l	#%0000_0001,d2
	subq.w	#1,d6
@@:
	add.w	d1,a5
	add.w	d1,a4
	add.w	d1,a3
	add.w	d1,a2

	move.w	d6,d0
	ble	__tycopy_s

	move.b	d2,d5
	not.b	d5

	and.w	#%111,d0
	beq	@f
	subq.w	#1,d0
	moveq.l	#$80,d1
	asr.b	d0,d1
	move.b	d1,d3
	not.b	d1
@@:
	subq.w	#1,d7
__tycopy87_o_loop:
	movem.l	d7/a2-a5,-(sp)
	moveq.l	#32,d7

	move.b	(a5)+,d0
	and.b	d2,d0
	and.b	d5,(a4)
	or.b	d0,(a4)+

	move.b	(a3)+,d0
	and.b	d2,d0
	and.b	d5,(a2)
	or.b	d0,(a2)+

	move.w	d6,d4
@@:
	sub.w	d7,d4
	bmi	@f

	move.l	(a5)+,(a4)+
	move.l	(a3)+,(a2)+
	bra	@b
@@:
	add.w	d7,d4
	beq	__tycopy87_o_loop_next
@@:
	subq.w	#8,d4
	bmi	@f

	move.b	(a5)+,(a4)+
	move.b	(a3)+,(a2)+
	bra	@b
@@:
	cmp.w	#-8,d4
	beq	__tycopy87_o_loop_next

	move.b	(a5)+,d0
	and.b	d3,d0
	and.b	d1,(a4)
	or.b	d0,(a4)+

	move.b	(a3)+,d0
	and.b	d3,d0
	and.b	d1,(a2)
	or.b	d0,(a2)+
__tycopy87_o_loop_next:
	movem.l	(sp)+,d7/a2-a5
	add.w	a1,a2
	add.w	a1,a3
	add.w	a1,a4
	add.w	a1,a5
	dbra	d7,__tycopy87_o_loop
	rts

__tycopy87_e1:
	add.w	d1,a5
	add.w	d1,a4
	add.w	d1,a3
	add.w	d1,a2

	move.w	d6,d0
	ble	__tycopy_s

	move.b	d2,d5
	not.b	d5

	and.w	#%111,d0
	beq	@f
	subq.w	#1,d0
	moveq.l	#$80,d1
	asr.b	d0,d1
	move.b	d1,d3
	not.b	d1
@@:
	subq.w	#1,d7
__tycopy87_e_loop:
	movem.l	d7/a2-a5,-(sp)
	moveq.l	#32,d7

	move.b	(a5)+,d0
	and.b	d2,d0
	and.b	d5,(a4)
	or.b	d0,(a4)+

	move.b	(a3)+,d0
	and.b	d2,d0
	and.b	d5,(a2)
	or.b	d0,(a2)+

	move.w	d6,d4

	subq.w	#8,d4
	bmi	1f

	move.b	(a5)+,(a4)+
	move.b	(a3)+,(a2)+
@@:
	sub.w	d7,d4
	bmi	@f

	move.l	(a5)+,(a4)+
	move.l	(a3)+,(a2)+
	bra	@b
@@:
	add.w	d7,d4
	beq	__tycopy87_e_loop_next
@@:
	subq.w	#8,d4
	bmi	@f

	move.b	(a5)+,(a4)+
	move.b	(a3)+,(a2)+
	bra	@b
@@:
	cmp.w	#-8,d4
	beq	__tycopy87_e_loop_next
1:
	move.b	(a5)+,d0
	and.b	d3,d0
	and.b	d1,(a4)
	or.b	d0,(a4)+

	move.b	(a3)+,d0
	and.b	d3,d0
	and.b	d1,(a2)
	or.b	d0,(a2)+
__tycopy87_e_loop_next:
	movem.l	(sp)+,d7/a2-a5
	add.w	a1,a2
	add.w	a1,a3
	add.w	a1,a4
	add.w	a1,a5
	dbra	d7,__tycopy87_e_loop
	rts

__tycopy_s:
	neg.w	d0
	beq	1f
	moveq.l	#$ff,d1
	lsl.b	d0,d1
	not.b	d1
	eor.b	d1,d2		* ]ȃrbgNA
1:
	move.b	d2,d5
	not.b	d5
@@:
	subq.w	#1,d7
__tycopy_s_loop:
	move.b	(a5)+,d0
	and.b	d2,d0
	and.b	d5,(a4)
	or.b	d0,(a4)

	move.b	(a3)+,d0
	and.b	d2,d0
	and.b	d5,(a2)
	or.b	d0,(a2)

	add.w	a1,a2
	add.w	a1,a3
	add.w	a1,a4
	add.w	a1,a5
	dbra	d7,__tycopy_s_loop
	rts

__tycopy80_e1:
	add.w	d1,a5
	add.w	d1,a4
	add.w	d1,a3
	add.w	d1,a2

	move.w	d6,d0
	ble	__tycopy_s
	addq.w	#8,d6

	and.w	#%111,d0
	beq	@f
	subq.w	#1,d0
	moveq.l	#$80,d1
	asr.b	d0,d1
	move.b	d1,d3
	not.b	d1
@@:
	moveq.l	#32,d2
	subq.w	#1,d7
__tycopy80_e_loop:
	movem.l	a2-a5,-(sp)
	move.w	d6,d4
@@:
	sub.w	d2,d4
	bmi	@f

	move.l	(a5)+,(a4)+
	move.l	(a3)+,(a2)+
	bra	@b
@@:
	add.w	d2,d4
	beq	__tycopy80_e_loop_next
@@:
	subq.w	#8,d4
	bmi	@f

	move.b	(a5)+,(a4)+
	move.b	(a3)+,(a2)+
	bra	@b
@@:
	cmp.w	#-8,d4
	beq	__tycopy80_e_loop_next

	move.b	(a5)+,d0
	and.b	d3,d0
	and.b	d1,(a4)
	or.b	d0,(a4)+

	move.b	(a3)+,d0
	and.b	d3,d0
	and.b	d1,(a2)
	or.b	d0,(a2)+
__tycopy80_e_loop_next:
	movem.l	(sp)+,a2-a5
	add.w	a1,a2
	add.w	a1,a3
	add.w	a1,a4
	add.w	a1,a5
	dbra	d7,__tycopy80_e_loop
	rts

__tycopy80_o1:
	add.w	d1,a5
	add.w	d1,a4
	add.w	d1,a3
	add.w	d1,a2

	move.w	d6,d0
	ble	__tycopy_s

	and.w	#%111,d0
	beq	@f
	subq.w	#1,d0
	moveq.l	#$80,d1
	asr.b	d0,d1
	move.b	d1,d3
	not.b	d1
@@:
	moveq.l	#32,d2
	subq.w	#1,d7
__tycopy80_o_loop:
	movem.l	a2-a5,-(sp)
	move.w	d6,d4

	move.b	(a5)+,(a4)+
	move.b	(a3)+,(a2)+
@@:
	sub.w	d2,d4
	bmi	@f

	move.l	(a5)+,(a4)+
	move.l	(a3)+,(a2)+
	bra	@b
@@:
	add.w	d2,d4
	beq	__tycopy80_o_loop_next
@@:
	subq.w	#8,d4
	bmi	@f

	move.b	(a5)+,(a4)+
	move.b	(a3)+,(a2)+
	bra	@b
@@:
	cmp.w	#-8,d4
	beq	__tycopy80_o_loop_next

	move.b	(a5)+,d0
	and.b	d3,d0
	and.b	d1,(a4)
	or.b	d0,(a4)+

	move.b	(a3)+,d0
	and.b	d3,d0
	and.b	d1,(a2)
	or.b	d0,(a2)+
__tycopy80_o_loop_next:
	movem.l	(sp)+,a2-a5
	add.w	a1,a2
	add.w	a1,a3
	add.w	a1,a4
	add.w	a1,a5
	dbra	d7,__tycopy80_o_loop
	rts


	.end
