* c_twincloseall.s

	.include	core.mac
	.include	../twin.mac
	.include	../twin_version.mac

	.xdef	_c_twincloseall

	.xref	__twincuroff
	.xref	coreuse
	.xref	twinno
	.xref	twinwork
	.xref	blinktbl


*-------------------------------------------------------------------------------
* S[NGAj

	.text
_c_twincloseall:
	move.w	d0,d1			* d1.w = core No.
	lea	twinno,a1
	lea	coreuse,a2
	moveq.l	#0-1,d0
@@:
	addq.w	#1,d0
	tst.b	(a1,d0.w)
	bpl	1f

	move.w	d0,d2
	add.w	d2,d2
	cmp.w	(a2,d2.w),d1
	bne	@b			* core No. Ⴄ
	move.w	#-1,(a2,d2.w)		* tO

	movem.l	d0-d1/a1,-(sp)
	lea	twinwork,a0
	move.w	d0,d1
	mulu.w	#twinworksize,d1
	add.l	d1,a0

	move.w	tno(a0),d0
	move.w	d0,d1
	lsr.w	#3,d1
	and.w	#%111,d0
	lea	blinktbl,a1
	bclr.b	d0,(a1,d1.w)	* _Œ~
	clr.b	tcursw(a0)	* \~
	clr.b	tcurstat(a0)	* 
	movem.l	(sp)+,d0-d1/a1

	clr.b	(a1,d0.w)	* I[vtO
	bra	@b
1:
	beq	@b		* gp

	clr.l	d0
_c_twincloseall_end:
	rts

_c_twincloseall_error:
	moveq.l	#-1,d0
	bra	_c_twincloseall_end

	.end
