* core_main.s

	.include	doscall.mac
	.include	core.mac
	.include	../twin.mac
	.include	../twin_version.mac

	.xref	keep_check
	.xref	core_header
	.xref	core_entry
	.xref	core_version
	.xref	ID_name
	.xref	ID_version
	.xref	__core_check
	.xref	__core_init
	.xref	_twinblinkon
	.xref	_twinblinkoff


*-------------------------------------------------------------------------------
* C[`

	.bss
coresize:
	.ds.l	1

	.text
coremain:
	lea	$10(a0),a0
	sub.l	a0,a1
	move.l	a1,-(sp)
	move.l	a0,-(sp)
	DOS	__SETBLOCK
	addq.l	#8,sp

	sub.l	#$f0,a1			* a1.l = Ŝ̃TCY
	move.l	a1,coresize

	sub.l	#$10,a0
	move.l	a0,a1
	lea	ID_name,a0
	jsr	keep_check
	move.l	d0,d1

	tst.b	(a2)+
	beq	keep
	move.b	(a2)+,d0
	cmp.b	#'-',d0
	bne	keep

	move.b	(a2)+,d0
	cmp.b	#'r',d0
	beq	release
	cmp.b	#'R',d0
	beq	release
	cmp.b	#'h',d0
	beq	help
	cmp.b	#'H',d0
	beq	help
	bra	help

*-------------------------------------------------------------------------------
* HELP

	.data
message_help:
	.dc.b	'usage: twincore [-r]',13,10
	.dc.b	'	-r	풓',13,10
	.dc.b	13,10
	.dc.b	0

	.text
help:
	pea	message_help
	DOS	__PRINT
	addq.l	#4,sp
	move.w	#1,-(sp)
	DOS	__EXIT2

*-------------------------------------------------------------------------------
* 풓

	.data
message_release:
	.dc.b	'풓܂.',13,10
	.dc.b	0
message_release_ap:
	.dc.b	'core pĂ܂.',13,10
	.dc.b	0
message_release_error:
	.dc.b	'풓Ă܂.',13,10
	.dc.b	0
message_release_mfree_error:
	.dc.b	'Ɏs܂B',13,10
	.dc.b	0

	.text
release:
	cmp.l	#1,d1
	bne	release_error

	move.l	a0,-(sp)
	move.l	$100+4(a0),a0
	moveq.l	#2,d0
	jsr	(a0)
	move.l	(sp)+,a0
	tst.l	d0
	bne	release_ap

	move.l	a0,-(sp)
	lea	_twinblinkoff,a1
	sub.l	#core_header,a1
	add.w	#$100,a0
	add.l	a1,a0
	jsr	(a0)			* jsr _twinblinkoff
	move.l	(sp)+,a0

	pea	$10(a0)
	DOS	__MFREE			* 
	addq.l	#4,sp
	tst.l	d0
	bmi	release_mfree_error

	DOS	__EXIT

release_mfree_error:
	pea	message_release_mfree_error
	bra	release_print_exit

release_ap:
	pea	message_release_ap
	bra	release_print_exit

release_error:
	pea	message_release_error
release_print_exit:
	DOS	__PRINT
	addq.l	#4,sp
	move.w	#1,-(sp)
	DOS	__EXIT2

*-------------------------------------------------------------------------------
* 풓

	.data
message_keep:
	.dc.b	'twincore  ver. '
	TWIN_VERSION_STRING
	.dc.b	' 풓܂.',13,10
	.dc.b	0
message_keep_error:
	.dc.b	'ɏ풓Ă܂.',13,10
	.dc.b	0
message_keep_error2:
	.dc.b	'o[ẄႤvO풓Ă܂.',13,10
	.dc.b	0

	.text
keep:
	tst.l	d1
	bne	keep_error

	pea	message_keep
	DOS	__PRINT
	addq.l	#4,sp
	jsr	__core_init		* core ď풓
	jsr	_twinblinkon
	move.w	#$0000,-(sp)
	move.l	coresize,-(sp)
	DOS	__KEEPPR

keep_error:
	subq.l	#2,d0
	beq	keep_error2
	pea	message_keep_error
	bra	keep_print_exit

keep_error2:
	pea	message_keep_error2
keep_print_exit:
	DOS	__PRINT
	addq.l	#4,sp
	move.w	#1,-(sp)
	DOS	__EXIT2

	.end	coremain
