* keep_check.s

	.include	iocscall.mac
	.include	doscall.mac

	.xdef	keep_check

*-------------------------------------------------------------------------------
* }N`

_TO_SUPER	.macro
* X[p[oCU[[h
	clr.l	-(sp)
	DOS	__SUPER
	addq.l	#4,sp
	move.l	d0,-(sp)
	.endm

_TO_USER	.macro
		.local	super_end
* [U[[h
	move.l	(sp)+,d0
	bmi	super_end
	move.l	d0,-(sp)
	DOS	__SUPER
	addq.l	#4,sp
super_end:
	.endm

*-------------------------------------------------------------------------------
* 풓`FbN
*
* entry:
*   a0.l = ʕ̃AhX (name + versionݒ肷邱)
*   a1.l = ̃Ǘ|C^̃AhX
* return:
*   d0.l = 0 vO܂
*        = 1 łɏ풓ς݂ł
*        = 2 o[WႢł
*        = 3 G[ł (͕ۏ؂܂)
*   a0.l = Ǘ|C^̃AhX (d0.l = 1, 2̎AȊO͕s)

keep_check_register	reg	d1-d5/a1-a3

	.text
keep_check:
	movem.l	keep_check_register,-(sp)
	move.l	a0,a2
	move.l	a1,a3
	move.l	a0,d2
	sub.l	a1,d2			* d2.l = ʕ̐擪܂ł̃ItZbg

	moveq.l	#-1,d4
keep_check_name_length:
	addq.l	#1,d4
	tst.b	(a0)+
	bne	keep_check_name_length
					* d4.l = name̒îO܂܂Ȃj
	moveq.l	#-1,d5
keep_check_version_length:
	addq.l	#1,d5
	tst.b	(a0)+
	bne	keep_check_version_length
					* d5.l = version̒îO܂܂Ȃj
	move.l	d2,d3
	add.l	d4,d3
	add.l	d5,d3
	addq.l	#2,d3			* d3.l = ʕŌ̂O܂ł̃ItZbg

	_TO_SUPER

	move.l	a3,a0			* ̃Ǘ|C^eǂ
keep_check_backward_loop:

	.ifdef	__DEBUG__
	move.w	#'B',-(sp)
	DOS	__PUTCHAR
	addq.l	#2,sp
	.endif

	tst.l	$04(a0)			* e邩H
	beq	keep_check_forward_loop
	move.l	$04(a0),a0		* ẽǗ|C^𓾂
	bra	keep_check_backward_loop

keep_check_forward_loop:

	.ifdef	__DEBUG__
	move.w	#'F',-(sp)
	DOS	__PUTCHAR
	addq.l	#2,sp
	.endif

	move.l	$0c(a0),d0
	beq	keep_check_not_found	* Ȃ
	move.l	d0,a0
	move.l	$08(a0),d0
	lea	(a0,d3.l),a1
	cmp.l	a1,d0
	bls	keep_check_forward_loop	* ubN͈̔͊O
	lea	(a0,d2.l),a1
	cmp.l	a1,a2
	beq	keep_check_forward_loop	* gEEE

keep_check_forward_name:
	move.l	a2,d1
	move.l	d4,d0
keep_check_forward_name_compare:
	cmpm.b	(a2)+,(a1)+
	dbne	d0,keep_check_forward_name_compare
	beq	keep_check_forward_version
	move.l	d1,a2
	bra	keep_check_forward_loop	* name 玟ɂ

keep_check_forward_version:
	move.l	d5,d0
keep_check_forward_version_compare:
	cmpm.b	(a2)+,(a1)+
	dbne	d0,keep_check_forward_version_compare
	bne	keep_check_version_no_match	* o[WႤ݂Ȃ
	bra	keep_check_match

keep_check_not_found:
	moveq.l	#0,d0
	bra	keep_check_end

keep_check_match:
	moveq.l	#1,d0
	bra	keep_check_end

keep_check_version_no_match:
	moveq.l	#2,d0
	bra	keep_check_end

keep_check_error:
	moveq.l	#3,d0

keep_check_end:
	move.l	d0,d1
	_TO_USER

	.ifdef	__DEBUG__
	move.w	#13,-(sp)
	DOS	__PUTCHAR
	addq.l	#2,sp
	move.w	#10,-(sp)
	DOS	__PUTCHAR
	addq.l	#2,sp
	.endif

	move.l	d1,d0
	movem.l	(sp)+,keep_check_register
	rts

	.end
