* twinclear.s

	.include	twin.mac
	.include	twin_version.mac

	.xdef	_twinclear

	.xref	__get_twinwork
	.xref	__twincuroff
	.xref	__tput3
	.xref	__tclr3
	.xref	twinno


*-------------------------------------------------------------------------------
* int twinclear( win );
* TWIN *win;
*
* EBhȄs

	.text
_twinclear:
	link	a6,#-350		* X^bNɊm
	move.l	d3,-(sp)
	move.l	8(a6),d1

	jsr	__get_twinwork
	tst.l	d0
	bmi	_twinclear_error
	move.l	d0,a0			* a0.l = TWIN|C^

	tst.w	tdraw(a0)
	beq	_twinclear_error	* \

	jsr	__twincuroff

	move.l	tbufp(a0),d3
	beq	_twinclear_no_buffer

	movem.l	d0-d4/a0-a4,-(sp)
	move.l	d3,a1

	move.w	tx(a0),d1
	mulu.w	tfsize(a0),d1
	lsr.w	#1,d1
	move.w	ty(a0),d2
	mulu.w	tfsize(a0),d2

	move.l	a1,d0
	move.l	tvram(a0),a1
	move.l	d0,a0
	jsr	__tput3

	movem.l	(sp)+,d0-d4/a0-a4
	bra	_twinclear_next

_twinclear_no_buffer:
	movem.l	d0-d4/a0-a4,-(sp)

	move.w	twx(a0),d3
	addq.w	#2,d3
	mulu.w	tfsize(a0),d3
	lsr.w	#1,d3			* rbg

	move.w	twy(a0),d4
	addq.w	#2,d4
	mulu.w	tfsize(a0),d4		* crbg

	move.w	tx(a0),d1
	mulu.w	tfsize(a0),d1
	lsr.w	#1,d1
	move.w	ty(a0),d2
	mulu.w	tfsize(a0),d2

	move.l	tvram(a0),a1

	jsr	__tclr3
	movem.l	(sp)+,d0-d4/a0-a4
_twinclear_next:
	lea	twinno,a1
	move.w	tno(a0),d0
	bclr.b	#0,(a1,d0.w)
	clr.w	tdraw(a0)
	clr.l	d0
_twinclear_end:
	move.l	(sp)+,d3
	unlk	a6
	rts

_twinclear_error:
	moveq.l	#-1,d0
	bra	_twinclear_end

	.end
