* twinclose.s

	.include	twin.mac
	.include	twin_version.mac

	.xdef	_twinclose

	.xref	__get_twinno
	.xref	twinno
	.xref	__twincuroff
	.xref	blinktbl


*-------------------------------------------------------------------------------
* int twinclose( win );
* TWIN *win;
*
* [NGAj

	.text
_twinclose:
	move.l	4(sp),d1

	jsr	__get_twinno
	tst.l	d0
	bmi	_twinclose_error

	lea	twinno,a1
	tst.b	(a1,d0.w)
	bpl	_twinclose_error
	move.l	d1,a0

	movem.l	d0/a1,-(sp)
	move.w	tno(a0),d0
	move.w	d0,d1
	lsr.w	#3,d1
	and.w	#%111,d0
	lea	blinktbl,a1
	bclr.b	d0,(a1,d1.w)	* _Œ~
	clr.b	tcursw(a0)	* \~
	clr.b	tcurstat(a0)	* 
	movem.l	(sp)+,d0/a1

	clr.b	(a1,d0.w)	* I[vtO
	clr.l	d0
_twinclose_end:
	rts

_twinclose_error:
	moveq.l	#-1,d0
	bra	_twinclose_end

	.end
