* twinconsol.s

	.include	twin.mac
	.include	twin_version.mac

	.xdef	_twinconsol

	.xref	__get_twinwork
	.xref	__twincuron
	.xref	__twincuroff


*-------------------------------------------------------------------------------
* int twinconsol( win, xs, ys, xl, yl );
* TWIN *win;
* short xs, ys;		/* _Wʒu */
* short xl, yl;		/* ő包/s|P */

	.text
_twinconsol:
	link	a6,#-2
	movem.l	d3-d5,-(sp)
	movem.l	8(a6),d1-d5

	jsr	__get_twinwork
	tst.l	d0
	bmi	_twinconsol_error
	move.l	d0,a0			* a0.l = EChE|C^

	tst.w	d2
	bmi	_twinconsol_error
	cmp.w	twx(a0),d2
	bcc	_twinconsol_error

	tst.w	d3
	bmi	_twinconsol_error
	cmp.w	twy(a0),d3
	bcc	_twinconsol_error

	move.w	d2,d0
	add.w	d4,d0
	tst.w	d4
	bmi	_twinconsol_error
	cmp.w	twx(a0),d0
	bcc	_twinconsol_error

	move.w	d3,d0
	add.w	d5,d0
	tst.w	d5
	bmi	_twinconsol_error
	cmp.w	twy(a0),d0
	bcc	_twinconsol_error

	clr.w	d0
	move.b	tcursw(a0),d0
	move.w	d0,-2(a6)

	jsr	__twincuroff

	move.w	d2,txs(a0)
	move.w	d3,tys(a0)
	move.w	d4,txmax(a0)
	move.w	d5,tymax(a0)
	clr.w	tcurx(a0)
	clr.w	tcury(a0)

	tst.w	-2(a6)
	beq	@f
	jsr	__twincuron
@@:
	clr.l	d0
_twinconsol_end:
	movem.l	(sp)+,d3-d5
	unlk	a6
	rts

_twinconsol_error:
	moveq.l	#-1,d0
	bra	_twinconsol_end

	.end
