* twinlocate.s

	.include	twin.mac
	.include	twin_version.mac

	.xdef	_twinlocate

	.xref	__twincuron
	.xref	__twincuroff
	.xref	__get_twinwork


*-------------------------------------------------------------------------------
* int twinlocate( win, x, y );
* TWIN *win;
* short x, y;

	.text
_twinlocate:
	link	a6,#-2
	move.l	d3,-(sp)
	movem.l	8(a6),d1-d3

	jsr	__get_twinwork
	tst.l	d0
	bmi	_twinlocate_error
	move.l	d0,a0			* a0.l = EChE|C^

	tst.w	d2
	bmi	_twinlocate_error
	cmp.w	txmax(a0),d2
	bls	@f
	move.w	txmax(a0),d2
@@:
	tst.w	d3
	bmi	_twinlocate_error
	cmp.w	tymax(a0),d3
	bls	@f
	move.w	tymax(a0),d3
@@:
	clr.w	d0
	move.b	tcursw(a0),d0
	move.w	d0,-2(a6)

	jsr	__twincuroff

	clr.b	tcursw(a0)
	clr.b	tcurstat(a0)
	move.w	d2,tcurx(a0)
	move.w	d3,tcury(a0)

	tst.w	-2(a6)
	beq	@f
	jsr	__twincuron
@@:
	clr.l	d0
_twinlocate_end:
	move.l	(sp)+,d3
	unlk	a6
	rts

_twinlocate_error:
	moveq.l	#-1,d0
	bra	_twinlocate_end

	.end
